Unit AuditReportPreview;

Interface

Uses
  ActnList,
  Classes,
  ComCtrls,
  Controls,
  Dialogs,
  DialogsCAPRI,
  Forms,
  Graphics,
  ImgList,
  Messages,
  Qrctrls,
  QRExport,
  QRPrntr,
  QuickRpt,
  StdCtrls,
  SysUtils,
  ToolWin,
  Windows;

Type

  TQRCustomPreviewInterface = Class(TQRPreviewInterface)
  Public
    Function Show(AQRPrinter: TQRPrinter): TWinControl; Override;
    Function ShowModal(AQRPrinter: TQRPrinter): TWinControl; Override;
  End;

  TfrmAuditReportPreview = Class(TForm)
    ActionClose           : TAction;
    ActionFirst           : TAction;
    ActionLast            : TAction;
    ActionList1           : TActionList;
    ActionNext            : TAction;
    ActionPrevious        : TAction;
    ActionPrint           : TAction;
    ActionPrintSetup      : TAction;
    ActionSaveAs          : TAction;
    ActionZoom            : TAction;
    ActionZoomFitPage     : TAction;
    ActionZoomWindow      : TAction;
    ComboBoxZoomFactor    : TComboBox;
    ImageList1            : TImageList;
    Label1                : TLabel;
    QRPreview1            : TQRPreview;
    SaveDialogAuditReports: TSaveDialog;
    StatusBarPreview      : TStatusBar;
    ToolBar1              : TToolBar;
    ToolButton1           : TToolButton;
    ToolButton10          : TToolButton;
    ToolButton11          : TToolButton;
    ToolButton12          : TToolButton;
    ToolButton13          : TToolButton;
    ToolButton14          : TToolButton;
    ToolButton15          : TToolButton;
    ToolButton16          : TToolButton;
    ToolButton17          : TToolButton;
    ToolButton2           : TToolButton;
    ToolButton3           : TToolButton;
    ToolButton4           : TToolButton;
    ToolButton5           : TToolButton;
    ToolButton6           : TToolButton;
    ToolButton7           : TToolButton;
    ToolButton8           : TToolButton;
    ToolButton9           : TToolButton;
    UpDownZoom            : TUpDown;
    Procedure ActionCloseExecute(Sender: TObject);
    Procedure ActionFirstExecute(Sender: TObject);
    Procedure ActionLastExecute(Sender: TObject);
    Procedure ActionNextExecute(Sender: TObject);
    Procedure ActionPreviousExecute(Sender: TObject);
    Procedure ActionPrintExecute(Sender: TObject);
    Procedure ActionPrintSetupExecute(Sender: TObject);
    Procedure ActionSaveAsExecute(Sender: TObject);
    Procedure ActionZoomExecute(Sender: TObject);
    Procedure ActionZoomFitPageExecute(Sender: TObject);
    Procedure ActionZoomWindowExecute(Sender: TObject);
    Procedure FormActivate(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure FormShow(Sender: TObject);
    Procedure QRPreview1PageAvailable(Sender: TObject; PageNum: Integer);
    Procedure UpDownZoomClick(Sender: TObject; Button: TUDBtnType);
  Private
    { Private declarations }
    fQRPrinter: TQRPrinter;
  Public
    { Public declarations }
    Constructor Create(AOwner: TComponent; AQRPrinter: TQRPrinter); Reintroduce; Overload;
  End;

Var
  frmAuditReportPreview: TfrmAuditReportPreview;

Implementation

Uses
  audit,
  AuditReport,
  main;

{$R *.DFM}

Function TQRCustomPreviewInterface.Show(
  AQRPrinter: TQRPrinter): TWinControl;
Var
  frmAuditReportPreview: TfrmAuditReportPreview;
Begin
  frmAuditReportPreview := TfrmAuditReportPreview.Create(Application, AQRPrinter);
  frmAuditReportPreview.Show;
  Result := frmAuditReportPreview;
End;

Function TQRCustomPreviewInterface.ShowModal(
  AQRPrinter: TQRPrinter): TWinControl;
Var
  frmAuditReportPreview: TfrmAuditReportPreview;
Begin
  frmAuditReportPreview := TfrmAuditReportPreview.Create(Application, AQRPrinter);
  frmAuditReportPreview.ShowModal;
  Result := frmAuditReportPreview;
End;

Constructor TfrmAuditReportPreview.Create(AOwner: TComponent;
  AQRPrinter: TQRPrinter);
Begin
  Inherited Create(AOwner);
  fQRPrinter := AQRPrinter;
  QRPreview1.QRPrinter := AQRPrinter;
End;

Procedure TfrmAuditReportPreview.FormClose(Sender: TObject;
  Var Action: TCloseAction);
Begin
  fQRPrinter.ClosePreview(Self);
  If Not assigned(frmAuditTrail) Then
    exit;
  Action := caFree;
End;

Procedure TfrmAuditReportPreview.ActionSaveAsExecute(Sender: TObject);
Begin

  If SaveDialogAuditReports.Execute Then
  Begin
    frmAuditReport.QuickRep1.ExportToFilter(
      TQRCommaSeparatedFilter.Create(SaveDialogAuditReports.FileName));
  End;
End;

Procedure TfrmAuditReportPreview.ActionZoomExecute(Sender: TObject);
Begin
  QRPreview1.Zoom := StrToInt(ComboBoxZoomFactor.Text);
  QRPreview1.UpdateZoom;
End;

Procedure TfrmAuditReportPreview.ActionZoomFitPageExecute(Sender: TObject);
Begin
  QRPreview1.ZoomToFit;
End;

Procedure TfrmAuditReportPreview.ActionZoomWindowExecute(Sender: TObject);
Begin
  QRPreview1.ZoomToWidth;
End;

Procedure TfrmAuditReportPreview.ActionCloseExecute(Sender: TObject);
Begin
  self.Close;
End;

Procedure TfrmAuditReportPreview.ActionFirstExecute(Sender: TObject);
Begin
  QRPreview1.PageNumber := 1;
  QRPreview1.UpdateImage;
  StatusBarPreview.SimpleText := 'Page ' + IntToStr(QRPreview1.PageNumber) + ' of ' + IntToStr(QRPreview1.QRPrinter.AvailablePages);
End;

Procedure TfrmAuditReportPreview.ActionPreviousExecute(Sender: TObject);
Begin
  QRPreview1.PageNumber := QRPreview1.PageNumber - 1;
  If QRPreview1.PageNumber <= 0 Then
    QRPreview1.PageNumber := 1;
  QRPreview1.UpdateImage;
  StatusBarPreview.SimpleText := 'Page ' + IntToStr(QRPreview1.PageNumber) + ' of ' + IntToStr(QRPreview1.QRPrinter.AvailablePages);

End;

Procedure TfrmAuditReportPreview.ActionNextExecute(Sender: TObject);
Begin
  QRPreview1.PageNumber := QRPreview1.PageNumber + 1;
  If QRPreview1.PageNumber >= QRPreview1.QRPrinter.AvailablePages Then
    QRPreview1.PageNumber := QRPreview1.QRPrinter.AvailablePages;
  QRPreview1.UpdateImage;
  StatusBarPreview.SimpleText := 'Page ' + IntToStr(QRPreview1.PageNumber) + ' of ' + IntToStr(QRPreview1.QRPrinter.AvailablePages);
End;

Procedure TfrmAuditReportPreview.ActionLastExecute(Sender: TObject);
Begin
  QRPreview1.PageNumber := QRPreview1.QRPrinter.AvailablePages;
  QRPreview1.UpdateImage;
  StatusBarPreview.SimpleText := 'Page ' + IntToStr(QRPreview1.PageNumber) + ' of ' + IntToStr(QRPreview1.QRPrinter.AvailablePages);
End;

Procedure TfrmAuditReportPreview.ActionPrintExecute(Sender: TObject);
Begin
  QRPreview1.QRPrinter.Print;
End;

Procedure TfrmAuditReportPreview.ActionPrintSetupExecute(Sender: TObject);
Begin
  QRPreview1.QRPrinter.PrintSetup;
End;

Procedure TfrmAuditReportPreview.FormShow(Sender: TObject);
Begin
  ActionZoomFitPageExecute(application);
End;

Procedure TfrmAuditReportPreview.FormActivate(Sender: TObject);
Begin
  ComboBoxZoomFactor.ItemIndex := 2;
End;

Procedure TfrmAuditReportPreview.UpDownZoomClick(Sender: TObject;
  Button: TUDBtnType);
Begin
  If Button = btNext Then
    QRPreview1.Zoom := QRPreview1.Zoom + 1
  Else
    QRPreview1.Zoom := QRPreview1.Zoom - 1;

  ComboBoxZoomFactor.Text := IntToStr(QRPreview1.Zoom);
  Application.ProcessMessages;

  QRPreview1.UpdateZoom;
End;

Procedure TfrmAuditReportPreview.QRPreview1PageAvailable(Sender: TObject;
  PageNum: Integer);
Var
  temptext: String;
Begin
  exit;
  ActionLastExecute(application);
  tempText := frmAuditReport.QRExpr3.Value.strResult;
  ShowmessageCAPRI(tempText);
  If QRPreview1.QRPrinter.status = mpFinished Then
    StatusBarPreview.SimpleText := 'Page ' + IntToStr(QRPreview1.PageNumber) + ' of ' + tempText
  Else
    Application.ProcessMessages;
  ActionFirstExecute(Application);
End;

Initialization
  // This will replace the built-in preview
  RegisterPreviewClass(TQRCustomPreviewInterface);
End.
