unit EdtCancelReasons;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Fmcmpnts, Diaccess, Trpcb, Fmcntrls,
  ComCtrls;

type
  TfrmEdtCancelReasons = class(TForm)
    Panel1: TPanel;
    lbActive: TListBox;
    lbInactive: TListBox;
    btnMoveToInactive: TBitBtn;
    btnMoveToActive: TBitBtn;
    txtActive: TStaticText;
    txtInactive: TStaticText;
    FMGets1: TFMGets;
    FMLister1: TFMLister;
    FMFiler1: TFMFiler;
    StatusBar1: TStatusBar;
    btnCancel: TBitBtn;
    btnSaveNewActive: TBitBtn;
    btnAddName: TBitBtn;
    btnClose: TButton;
    txtAddName: TStaticText;
    FMEditName: TFMEdit;
    FMEditStatus: TFMEdit;
    txtStatus: TStaticText;
    btnGetList: TButton;
    btnDeleteInactive: TButton;
    btnDeleteActiveReason: TButton;
    procedure btnMoveToInactiveClick(Sender: TObject);
    procedure btnMoveToActiveClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnAddNameClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnSaveNewActiveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnGetListClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
//    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnDeleteInactiveClick(Sender: TObject);
    procedure btnDeleteActiveReasonClick(Sender: TObject);
  private
    { Private declarations }
    function DeleteReason(inIENS: String): Boolean;
    function FileChanges: Boolean;
    procedure LoadDataIntoListboxes;
    function SaveItem(ItemIEN, ItemName: String; ItemState: Boolean): Boolean;
    function SaveNewItem: Boolean;
    function UpdateItemState(ItemIEN, ItemName: string; ItemState: Boolean): Boolean;
    procedure FreeListBoxes;
  public
    { Public declarations }
  end;

var
  frmEdtCancelReasons: TfrmEdtCancelReasons;

implementation
uses
  main, DiTypLib, VA508AccessibilityRouter;

{$R *.dfm}

type
  TIENInfo = class
    IEN: String;
  end;

var
  AddRecord: Boolean;
  AddedIENS: String;

procedure TfrmEdtCancelReasons.btnAddNameClick(Sender: TObject);
begin
  StatusBar1.SimpleText := '';
  btnAddName.Visible := FALSE;
  txtAddName.Visible := TRUE;
  FMEditName.Show;
//  txtStatus.Show;
//  FMEditStatus.Show;
  btnSaveNewActive.Visible := TRUE;
  btnCancel.Visible := TRUE;

  FMEditName.Enabled := True;
  FMEditName.FMRequired := False;
  FMEditName.FMCtrlOptions := [];

  FMEditStatus.Enabled := False;
  FMEditStatus.FMRequired := False;
  FMEditStatus.FMCtrlOptions := [];

  FMFiler1.Clear;
  FMGets1.ClearCtrlData;
  FMGets1.IENS := '+1,';

  FMGets1.StuffIENS('+1,');

  FMEditName.FMRequired := True;
//  FMEditName.FMCtrlOptions := [coValOnExit];
  FMEditName.Text := 'Enter Reason';
  FMEditName.FMCtrlInternal := 'ENTER REASON';

  FMEditStatus.FMCtrlOptions := [coValOnExit];
  FMEditStatus.Text := 'A';
  FMEditStatus.FMCtrlInternal := '1';                                           // Status = Active

  if FMEditName.CanFocus then
    FMEditName.SetFocus;

  AddRecord := True;
end;                                                                            // btnAddNameClick

procedure TfrmEdtCancelReasons.btnCancelClick(Sender: TObject);
begin
  StatusBar1.SimpleText := '';
  txtAddName.Visible := FALSE;
  FMEditName.Hide;
  txtStatus.Hide;
  FMEditStatus.Hide;
  btnSaveNewActive.Visible := FALSE;
  btnCancel.Visible := FALSE;
  btnAddName.Visible := TRUE;
  FMFiler1.Clear;
end;                                                                            // btnCancelClick

procedure TfrmEdtCancelReasons.btnCloseClick(Sender: TObject);
begin
  Close;
end;                                                                            // btnCloseClick

procedure TfrmEdtCancelReasons.btnDeleteActiveReasonClick(Sender: TObject);
var
  IENS: String;
  tmpobj: TObject;
begin
  StatusBar1.SimpleText := '';
  if lbActive.ItemIndex >= 0 then begin
    tmpobj := lbActive.Items.Objects[lbActive.ItemIndex];
    if tmpobj <> nil then begin
      IENS := TIENInfo(tmpobj).IEN;
      DeleteReason(IENS);
    end;
  end;
end;

procedure TfrmEdtCancelReasons.btnDeleteInactiveClick(Sender: TObject);
var
  IENS: String;
  tmpobj: TObject;
begin
  StatusBar1.SimpleText := '';
  if lbInactive.ItemIndex >= 0 then begin
    tmpobj := lbInactive.Items.Objects[lbInactive.ItemIndex];
    if tmpobj <> nil then begin
      IENS := TIENInfo(tmpobj).IEN;
      DeleteReason(IENS);
    end;
  end;
end;

procedure TfrmEdtCancelReasons.btnGetListClick(Sender: TObject);
begin
  LoadDataIntoListBoxes;
end;

procedure TfrmEdtCancelReasons.btnMoveToActiveClick(Sender: TObject);
var
  Index, idx: Integer;
  IENS: String;
  tmpobj: TObject;
  AIENInfo: TIENInfo;
begin
  StatusBar1.SimpleText := '';
  Index := lbInactive.ItemIndex;
  if Index >= 0 then begin
    tmpobj := lbInactive.Items.Objects[Index];
    if tmpobj <> nil then begin
      IENS := TIENInfo(tmpobj).IEN;
      if UpdateItemState(IENS, lbInactive.items[Index], TRUE) then begin
        AIENInfo := TIENInfo.Create;
        try
          AIENInfo.IEN := IENS;
          idx := lbActive.Items.AddObject(lbInactive.Items[Index], AIENInfo);
        finally
          tmpobj.Free;
          lbInactive.Items.Delete(Index);
        end;
      end;
    end;
  end;
end;                                                                            // btnMoveToActiveClick

procedure TfrmEdtCancelReasons.btnMoveToInactiveClick(Sender: TObject);
var
  Index, idx: Integer;
  IENS: String;
  tmpobj: TObject;
  AIENInfo: TIENInfo;
begin
  StatusBar1.SimpleText := '';
  Index := lbActive.ItemIndex;
  if Index >= 0 then begin
    tmpobj := lbActive.Items.Objects[Index];
    if tmpobj <> nil then begin
      IENS := TIENInfo(tmpobj).IEN;
      if UpdateItemState(IENS, lbActive.Items[Index], FALSE) then begin
        AIENInfo := TIENInfo.Create;
        try
          AIENInfo.IEN := IENS;
          idx := lbInactive.Items.AddObject(lbActive.Items[Index], AIENInfo);
        finally
          tmpobj.Free;
          lbActive.Items.Delete(Index);
        end;
      end;
    end;
  end;
end;                                                                            // btnMoveToInactiveClick

procedure TfrmEdtCancelReasons.btnSaveNewActiveClick(Sender: TObject);
var
  idx: Integer;
  bret: Boolean;
  AIENInfo: TIENInfo;
begin
  bret := SaveNewItem;
  if bret then begin
    AIENInfo := TIENInfo.Create;
    try
      AIENInfo.IEN := FMGets1.IENS;
      if FMEditName.Text > '' then
        idx := lbActive.Items.AddObject(FMEditName.Text, AIENInfo);
    finally
      txtAddName.Visible := FALSE;
      btnAddName.Visible := TRUE;
      FMEditName.Hide;
      txtStatus.Hide;
      FMEditStatus.Hide;
      btnSaveNewActive.Visible := FALSE;
      btnCancel.Visible := FALSE;
    end;
  end;
end;                                                                            // btnSaveNewActiveClick

function TfrmEdtCancelReasons.DeleteReason(inIENS: String): Boolean;
begin
  Result := False;
  StatusBar1.SimpleText := '';
  FMGets1.IENS := inIENS;
  if DeleteRecord(frmMain.RPCBroker1, FMGets1.FileNumber, FMGets1.IENS) then begin
    LoadDataIntoListBoxes;
    Result := True;
  end
  else
    StatusBar1.SimpleText := 'There was a problem deleting the record.';
end;

function TfrmEdtCancelReasons.FileChanges: Boolean;
begin
  Result := False;
  StatusBar1.SimpleText := '';
  if FMFiler1.DataProblemCheck then
    FMFiler1.ProcessDataProblemList
  else if FMFiler1.Update then begin
//    StatusBar1.SimpleText := 'Changes Filed.';
    Result := True;
  end
  else
    FMFiler1.DisplayErrors;
end;                                                                            // FileChanges


{ procedure TfrmEdtCancelReasons.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  btnval: Integer;
  bret: Boolean;
begin
  CanClose := True;

  if FMFiler1.AnythingToFile then begin
    btnval := MessageDlg('Save Changes?', mtConfirmation, mbYesNoCancel, 0);
    if btnval = mrYes then
      bret := FileChanges
    else if btnval = mrNo then
      FMFiler1.Clear
    else if btnval = mrCancel then
      CanClose := False;
  end;

end; }

procedure TfrmEdtCancelReasons.FormCreate(Sender: TObject);
begin
  frmMain.RPCBroker1.Connected := True;
  btnAddName.Visible := TRUE;
  FMEditName.Hide;
  FMEditStatus.Hide;
  btnSaveNewActive.Visible := FALSE;
  btnCancel.Visible := FALSE;
  txtAddName.Visible := FALSE;
  txtStatus.Hide;
end;

procedure TfrmEdtCancelReasons.FormDestroy(Sender: TObject);
begin
  FreeListBoxes;
end;

procedure TfrmEdtCancelReasons.FormShow(Sender: TObject);
begin
  LoadDataIntoListBoxes;
end;

procedure TfrmEdtCancelReasons.FreeListBoxes;
var
  i: Integer;
  AIENInfo: TIENInfo;
begin
  for I := 0 to lbActive.Count - 1 do
    if lbActive.Items.Objects[i] <> nil then begin
      AIENInfo := TIENInfo(lbActive.Items.Objects[i]);
      AIENInfo.Free;
    end;
  lbActive.Clear;

  for I := 0 to lbInactive.Count - 1 do
    if lbInactive.Items.Objects[i] <> nil then begin
      AIENInfo := TIENInfo(lbInactive.Items.Objects[i]);
      AIENInfo.Free;
    end;
  lbInactive.Clear;

end;

procedure TfrmEdtCancelReasons.LoadDataIntoListboxes;
var
  i, icnt, idx: Integer;
  fmRecObj: TFMRecordObj;
  name, status, IENS: String;
  AIENInfo: TIENInfo;
begin
  // Initialize listboxes
  FreeListBoxes;

  FMLister1.GetList(nil);
  if FMLister1.ErrorList.Count > 0 then
    FMLister1.DisplayErrors
  else begin
    icnt := FMLister1.Results.Count;
    for I := 0 to icnt - 1 do begin
      IENS := FMLister1.Results[i];
      if IENS > '' then begin
        fmRecObj := TFMRecordObj(FMLister1.Results.Objects[i]);
        name := fmRecObj.GetField('.01').FMDBExternal;
        status := fmRecObj.GetField('.02').FMDBExternal;
        AIENInfo := TIENInfo.Create;
        AIENInfo.IEN := IENS;
        if status = 'ACTIVE' then begin                                         // inactive = no
          idx := lbActive.Items.AddObject(name, AIENInfo);
        end
        else begin                                                              // inactive = yes
          idx := lbInactive.Items.AddObject(name, AIENInfo);
        end;
      end;
    end;
  end;
end;                                                                            // LoadDataIntoListboxes

function TfrmEdtCancelReasons.SaveItem(ItemIEN, ItemName: String; ItemState: Boolean): Boolean;
var
  update: Boolean;
  IENS: String;
  cpos, ilen: Integer;

  procedure StatusMsg(inMsg: String);
  begin
    StatusBar1.SimpleText := inmsg;
    GetScreenReader.Speak(inmsg);
  end;

begin
  StatusBar1.SimpleText := '';
  IENS := '';
  update := False;
  Result := True;

  if ItemIEN > '' then
    FMGets1.IENS := ItemIEN;

  if ItemName > '' then begin
    FMEditName.Text := ItemName;
    FMEditName.FMCtrlInternal := ItemName;
  end
  else
    FMEditName.FMCtrlInternal := FMEditName.Text;

  if ItemState then begin
    FMEditStatus.Text := 'A';
    FMEditStatus.FMCtrlInternal := '1';                                         // Status = active
  end
  else begin
    FMEditStatus.Text := 'I';
    FMEditStatus.FMCtrlInternal := '0';                                         // Status = inactive
  end;

  if (FMGets1.IENS > '') then begin
    StatusBar1.SimpleText := '';
    ilen := Length(FMEditname.Text);
    if ilen < 3 then begin
//      StatusBar1.SimpleText := 'Reason must be at least three characters in length.';
      StatusMsg('Reason must be at least three characters in length.');
      if FMEditName.CanFocus then
        FMEditName.SetFocus;
      Result := False;
      exit;
    end;
    FMEditName.IENS := FMGets1.IENS;
    if FMEditName.FMModified then
      if FMEditName.Validate then begin
        FMFiler1.AddChgdControl(FMEditName);
        FMEditName.Text := FMEditName.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditName.Text := FMEditName.FMTag;
        Result := False;
      end;

    FMEditStatus.IENS := FMGets1.IENS;
    if FMEditStatus.FMModified then
      if FMEditStatus.Validate then begin
        FMFiler1.AddChgdControl(FMEditStatus);
        FMEditStatus.Text := FMEditStatus.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditStatus.Text := FMEditStatus.FMTag;
        Result := False;
      end;

    if Result then begin
      if FMFiler1.AnythingToFile then begin
        update := FileChanges;
        Result := update;
        if update then begin

          if AddRecord then begin
            IENS := FMFiler1.FindIen('+1,') + ',';
            if IENS <> ',' then begin
              cpos := Pos(',', IENS);
              AddedIENS := Copy(IENS, 1, cpos - 1);
//              StatusBar1.SimpleText := 'Record added.';
              StatusMsg('Record added.');
              Result := True;
            end
            else begin
              IENS := '';
//              StatusBar1.SimpleText := 'New record not found.';
              StatusMsg('New record not found.');
              Result := False;
            end;
          end;                                                                  // if AddRecord
//        else
//          StatusBar1.SimpleText := 'Record saved.';

          if IENS > '' then begin
            FMGets1.IENS := IENS;
            FMGets1.GetAndFill;
//          FMEditName.Invalidate;
//          FMEditStatus.Invalidate;
          end;                                                                  // if IENS > ''
        end;                                                                    // if update
      end                                                                       // if AnythingToFile
      else
//        StatusBar1.SimpleText := 'No changes to file!';
        StatusMsg('No changes to file!');
    end;                                                                        // if Result
  end;                                                                          // if IENS > ''

  AddRecord := False;
  AddedIENS := '';
//  FMEditName.Text := '';

  Invalidate;

end;                                                                            // SaveItem

function TfrmEdtCancelReasons.SaveNewItem: Boolean;
begin
  // Save Item and return save status
  Result := SaveItem('', '', True);
end;

function TfrmEdtCancelReasons.UpdateItemState(ItemIEN, ItemName: string;
  ItemState: Boolean): Boolean;
begin
  // Update Item State
  if AddRecord then
    btnCancel.Click;
  AddRecord := False;
  Result := SaveItem(ItemIEN, ItemName, ItemState);
end;

initialization
SpecifyFormIsNotADialog(TfrmEdtCancelReasons);

end.

