unit EdtReRouteReasons;
//------------------------------------------------------------------------------
// Patch 193 JRL 5/1/16
// This screen was added for the Re-Route Exam Request function in Patch 193.
//------------------------------------------------------------------------------
// 396.55,.01 REROUTE CODE - 3-30 chars - Reason for rerouting the 2507 to another VMCA.
// 396.55,.02 ACTIVE - 'A' for Active, 'I' for Inactive
//------------------------------------------------------------------------------

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Fmcmpnts, Diaccess, StdCtrls, Fmcntrls, Buttons, ComCtrls, ExtCtrls,
  VA508AccessibilityManager;

type
  TfrmEdtReRouteReasons = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    txtActive: TStaticText;
    lbActive: TListBox;
    txtInactive: TStaticText;
    lbInactive: TListBox;
    btnMoveToInactive: TBitBtn;
    btnMoveToActive: TBitBtn;
    btnAddReason: TBitBtn;
    txtAddName: TStaticText;
    FMEditName: TFMEdit;
    btnSaveNewActive: TBitBtn;
    btnCancel: TBitBtn;
    btnClose: TButton;
    txtStatus: TStaticText;
    FMEditStatus: TFMEdit;
    btnGetList: TButton;
    btnDeleteActiveReason: TButton;
    btnDeleteInactive: TButton;
    FMLister1: TFMLister;
    FMGets1: TFMGets;
    FMFiler1: TFMFiler;
    VA508StaticText1: TVA508StaticText;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnAddReasonClick(Sender: TObject);
    procedure btnDeleteInactiveClick(Sender: TObject);
    procedure btnMoveToInactiveClick(Sender: TObject);
    procedure btnMoveToActiveClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnSaveNewActiveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnGetListClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnDeleteActiveReasonClick(Sender: TObject);
  private
    { Private declarations }
    function  DeleteReason(inIENS: String): Boolean;
    procedure LoadDataIntoListboxes;
    procedure FreeListBoxes;
    function  FileChanges: Boolean;
    function  UpdateItemState(ItemIEN, ItemName: string; ItemState: Boolean): Boolean;
    function  SaveNewItem: Boolean;
    function  SaveItem(ItemIEN, ItemName: String; ItemState: Boolean): Boolean;
    procedure IsDelphiRunning;
    
  public
    { Public declarations }
  end;

var
  frmEdtReRouteReasons: TfrmEdtReRouteReasons;

implementation
uses
  Main,
  DiTypLib,
  VA508AccessibilityRouter
  ;

{$R *.dfm}

type
  TIENInfo = class
    IEN: String;
  end;

var
  AddRecord: Boolean;
  AddedIENS: String;

//------------------------------------------------------------------------------
// Add Reason button clicked
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.btnAddReasonClick(Sender: TObject);
begin
  StatusBar1.SimpleText := '';
  btnAddReason.Visible := FALSE;
  txtAddName.Visible := TRUE;
  FMEditName.Show;
  btnSaveNewActive.Visible := TRUE;
  btnCancel.Visible := TRUE;

  FMEditName.Enabled := True;
  FMEditName.FMRequired := False;
  FMEditName.FMCtrlOptions := [];

  FMEditStatus.Enabled := False;
  FMEditStatus.FMRequired := False;
  FMEditStatus.FMCtrlOptions := [];

  FMFiler1.Clear;
  FMGets1.ClearCtrlData;
  FMGets1.IENS := '+1,';

  FMGets1.StuffIENS('+1,');

  FMEditName.FMRequired := True;
//  FMEditName.FMCtrlOptions := [coValOnExit];
  FMEditName.Text := 'Enter Reason';
  FMEditName.FMCtrlInternal := 'ENTER REASON';

  FMEditStatus.FMCtrlOptions := [coValOnExit];
  FMEditStatus.Text := 'A';
  FMEditStatus.FMCtrlInternal := '1';                                           // Status = Active

  if FMEditName.CanFocus then
    FMEditName.SetFocus;

  AddRecord := True;

end;

//------------------------------------------------------------------------------
// Cancel button clicked
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.btnCancelClick(Sender: TObject);
begin
  StatusBar1.SimpleText := '';
  txtAddName.Visible := FALSE;
  FMEditName.Hide;
  txtStatus.Hide;
  FMEditStatus.Hide;
  btnSaveNewActive.Visible := FALSE;
  btnCancel.Visible := FALSE;
  btnAddReason.Visible := TRUE;
  FMFiler1.Clear;
end;

//------------------------------------------------------------------------------
// Close button clicked
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.btnCloseClick(Sender: TObject);
begin
  Close;
end;

//------------------------------------------------------------------------------
// File Changes
//------------------------------------------------------------------------------
function TfrmEdtReRouteReasons.FileChanges: Boolean;
begin
  Result := False;
  StatusBar1.SimpleText := '';
  if FMFiler1.DataProblemCheck then
    FMFiler1.ProcessDataProblemList
  else if FMFiler1.Update then begin  // changes filed
    Result := True;
  end
  else
    FMFiler1.DisplayErrors;

end;

//------------------------------------------------------------------------------
// Form Create
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.FormCreate(Sender: TObject);
begin
  frmMain.RPCBroker1.Connected := True;
  btnAddReason.Visible := TRUE;
  FMEditName.Hide;
  FMEditStatus.Hide;
  btnSaveNewActive.Visible := FALSE;
  btnCancel.Visible := FALSE;
  txtAddName.Visible := FALSE;
  txtStatus.Hide;
end;

//------------------------------------------------------------------------------
// Form Show
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.FormShow(Sender: TObject);
begin
  LoadDataIntoListBoxes;
  IsDelphiRunning;  // Show test buttons if Delphi is running
end;

//------------------------------------------------------------------------------
// Form Destroy
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.FormDestroy(Sender: TObject);
begin
  FreeListBoxes;
end;

//------------------------------------------------------------------------------
// Free List Boxes
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.FreeListBoxes;
var
  i: Integer;
  AIENInfo: TIENInfo;
begin
  for I := 0 to lbActive.Count - 1 do
    if lbActive.Items.Objects[i] <> nil then begin
      AIENInfo := TIENInfo(lbActive.Items.Objects[i]);
      AIENInfo.Free;
    end;
  lbActive.Clear;

  for I := 0 to lbInactive.Count - 1 do
    if lbInactive.Items.Objects[i] <> nil then begin
      AIENInfo := TIENInfo(lbInactive.Items.Objects[i]);
      AIENInfo.Free;
    end;
  lbInactive.Clear;
end;

//------------------------------------------------------------------------------
// Move to Active button clicked
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.btnMoveToActiveClick(Sender: TObject);
var
  Index, idx: Integer;
  IENS: String;
  tmpobj: TObject;
  AIENInfo: TIENInfo;
begin
  StatusBar1.SimpleText := '';
  Index := lbInactive.ItemIndex;
  if Index >= 0 then begin
    tmpobj := lbInactive.Items.Objects[Index];
    if tmpobj <> nil then begin
      IENS := TIENInfo(tmpobj).IEN;
      if UpdateItemState(IENS, lbInactive.items[Index], TRUE) then begin
        AIENInfo := TIENInfo.Create;
        try
          AIENInfo.IEN := IENS;
          idx := lbActive.Items.AddObject(lbInactive.Items[Index], AIENInfo);
        finally
          tmpobj.Free;
          lbInactive.Items.Delete(Index);
        end;
      end;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Move to Inactive button clicked
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.btnMoveToInactiveClick(Sender: TObject);
var
  Index, idx: Integer;
  IENS: String;
  tmpobj: TObject;
  AIENInfo: TIENInfo;
begin
  StatusBar1.SimpleText := '';
  Index := lbActive.ItemIndex;
  if Index >= 0 then begin
    tmpobj := lbActive.Items.Objects[Index];
    if tmpobj <> nil then begin
      IENS := TIENInfo(tmpobj).IEN;
      if UpdateItemState(IENS, lbActive.Items[Index], FALSE) then begin
        AIENInfo := TIENInfo.Create;
        try
          AIENInfo.IEN := IENS;
          idx := lbInactive.Items.AddObject(lbActive.Items[Index], AIENInfo);
        finally
          tmpobj.Free;
          lbActive.Items.Delete(Index);
        end;
      end;
    end;
  end;
end;


//------------------------------------------------------------------------------
// Save New Active Reason
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.btnSaveNewActiveClick(Sender: TObject);
var
  idx: Integer;
  bret: Boolean;
  AIENInfo: TIENInfo;
begin
  bret := SaveNewItem;
  if bret then begin
    AIENInfo := TIENInfo.Create;
    try
      AIENInfo.IEN := FMGets1.IENS;
      if FMEditName.Text > '' then
        idx := lbActive.Items.AddObject(FMEditName.Text, AIENInfo);
    finally
      txtAddName.Visible := FALSE;
      btnAddReason.Visible := TRUE;
      FMEditName.Hide;
      txtStatus.Hide;
      FMEditStatus.Hide;
      btnSaveNewActive.Visible := FALSE;
      btnCancel.Visible := FALSE;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Load Data Into List Boxes
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.LoadDataIntoListboxes;
var
  i, icnt, idx: Integer;
  fmRecObj: TFMRecordObj;
  name, status, IENS: String;
  AIENInfo: TIENInfo;
begin
  // Initialize listboxes
  FreeListBoxes;

  FMLister1.GetList(nil);
  if FMLister1.ErrorList.Count > 0 then
    FMLister1.DisplayErrors
  else begin
    icnt := FMLister1.Results.Count;
    for I := 0 to icnt - 1 do begin
      IENS := FMLister1.Results[i];
      if IENS > '' then begin
        fmRecObj := TFMRecordObj(FMLister1.Results.Objects[i]);
        name := fmRecObj.GetField('.01').FMDBExternal;
        status := uppercase(fmRecObj.GetField('.02').FMDBExternal);
        AIENInfo := TIENInfo.Create;
        AIENInfo.IEN := IENS;
        if status = 'ACTIVE' then begin                                         // inactive = no
          idx := lbActive.Items.AddObject(name, AIENInfo);
        end
        else begin                                                              // inactive = yes
          idx := lbInactive.Items.AddObject(name, AIENInfo);
        end;
      end;
    end;
  end;
end;


//------------------------------------------------------------------------------
// Save Item
//------------------------------------------------------------------------------
function TfrmEdtReRouteReasons.SaveItem(ItemIEN, ItemName: String;
  ItemState: Boolean): Boolean;
var
  update: Boolean;
  IENS: String;
  cpos, ilen: Integer;

  procedure StatusMsg(inMsg: String);
  begin
    StatusBar1.SimpleText := inmsg;
    GetScreenReader.Speak(inmsg);
  end;
begin
  StatusBar1.SimpleText := '';
  IENS := '';
  update := False;
  Result := True;

  if ItemIEN > '' then
    FMGets1.IENS := ItemIEN;

  if ItemName > '' then begin
    FMEditName.Text := ItemName;
    FMEditName.FMCtrlInternal := ItemName;
  end
  else
    FMEditName.FMCtrlInternal := FMEditName.Text;

  if ItemState then begin
    FMEditStatus.Text := 'A';
    FMEditStatus.FMCtrlInternal := '1';                                         // Status = active
  end
  else begin
    FMEditStatus.Text := 'I';
    FMEditStatus.FMCtrlInternal := '0';                                         // Status = inactive
  end;

  if (FMGets1.IENS > '') then begin
    StatusBar1.SimpleText := '';
    ilen := Length(FMEditname.Text);
    if ilen < 3 then begin
      StatusMsg('Reason must be at least three characters in length.');
      if FMEditName.CanFocus then
        FMEditName.SetFocus;
      Result := False;
      exit;
    end;
    FMEditName.IENS := FMGets1.IENS;
    if FMEditName.FMModified then
      if FMEditName.Validate then begin
        FMFiler1.AddChgdControl(FMEditName);
        FMEditName.Text := FMEditName.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditName.Text := FMEditName.FMTag;
        Result := False;
      end;

    FMEditStatus.IENS := FMGets1.IENS;
    if FMEditStatus.FMModified then
      if FMEditStatus.Validate then begin
        FMFiler1.AddChgdControl(FMEditStatus);
        FMEditStatus.Text := FMEditStatus.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditStatus.Text := FMEditStatus.FMTag;
        Result := False;
      end;

    if Result then begin
      if FMFiler1.AnythingToFile then begin
        update := FileChanges;
        Result := update;
        if update then begin

          if AddRecord then begin
            IENS := FMFiler1.FindIen('+1,') + ',';
            if IENS <> ',' then begin
              cpos := Pos(',', IENS);
              AddedIENS := Copy(IENS, 1, cpos - 1);
              StatusMsg('Record added.');
              Result := True;
            end
            else begin
              IENS := '';
              StatusMsg('New record not found.');
              Result := False;
            end;
          end;                                                                  // if AddRecord

          if IENS > '' then begin
            FMGets1.IENS := IENS;
            FMGets1.GetAndFill;
          end;                                                                  // if IENS > ''
        end;                                                                    // if update
      end                                                                       // if AnythingToFile
      else
        StatusMsg('No changes to file!');
    end;                                                                        // if Result
  end;                                                                          // if IENS > ''

  AddRecord := False;
  AddedIENS := '';
  Invalidate;
end;

function TfrmEdtReRouteReasons.SaveNewItem: Boolean;
begin
  // Save Item and return save status
  Result := SaveItem('', '', True);
end;

//------------------------------------------------------------------------------
// Update Item State
//------------------------------------------------------------------------------
function TfrmEdtReRouteReasons.UpdateItemState(ItemIEN, ItemName: string;
  ItemState: Boolean): Boolean;
begin
  // Update Item State
  if AddRecord then
    btnCancel.Click;
  AddRecord := False;
  Result := SaveItem(ItemIEN, ItemName, ItemState);
end;

//------------------------------------------------------------------------------
// DEBUG ROUTINE - Get List button clicked
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.btnGetListClick(Sender: TObject);
begin
  LoadDataIntoListBoxes;
end;

//------------------------------------------------------------------------------
// DEBUG ROUTINE - Delete Active Reason button Clicked
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.btnDeleteActiveReasonClick(Sender: TObject);
var
  IENS: String;
  tmpobj: TObject;
begin
  StatusBar1.SimpleText := '';
  if lbActive.ItemIndex >= 0 then begin
    tmpobj := lbActive.Items.Objects[lbActive.ItemIndex];
    if tmpobj <> nil then begin
      IENS := TIENInfo(tmpobj).IEN;
      DeleteReason(IENS);
    end;
  end;
end;

//------------------------------------------------------------------------------
// DEBUG ROUTINE - Delete Inactive Reason button Clicked
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.btnDeleteInactiveClick(Sender: TObject);
var
  IENS: String;
  tmpobj: TObject;
begin
  StatusBar1.SimpleText := '';
  if lbActive.ItemIndex >= 0 then begin
    tmpobj := lbActive.Items.Objects[lbActive.ItemIndex];
    if tmpobj <> nil then begin
      IENS := TIENInfo(tmpobj).IEN;
      DeleteReason(IENS);
    end;
  end;
end;

//------------------------------------------------------------------------------
// DEBUG ROUTINE - Delete Reason
//------------------------------------------------------------------------------
function TfrmEdtReRouteReasons.DeleteReason(inIENS: String): Boolean;
begin
  Result := False;
  StatusBar1.SimpleText := '';
  FMGets1.IENS := inIENS;
  if DeleteRecord(frmMain.RPCBroker1, FMGets1.FileNumber, FMGets1.IENS) then begin
    LoadDataIntoListBoxes;
    Result := True;
  end
  else
    StatusBar1.SimpleText := 'There was a problem deleting the record.';
end;

//------------------------------------------------------------------------------
// Is Delphi Running?
//------------------------------------------------------------------------------
// If Delphi is running, we are in the IDE and operating in a testing mode.  
// Display testing buttons.  If Delphi is not running, do not display test 
// buttons.
//------------------------------------------------------------------------------
// Debug routines were included because they existed in the Cancellation 
// Reasons code and this form was derived from that.  I've added the 
// IsDelphiRunning code to show the test buttons in the development mode but
// none of the test routines have been "tested" for this form.
//------------------------------------------------------------------------------
procedure TfrmEdtReRouteReasons.IsDelphiRunning;
begin
  if DebugHook <> 0 then
  begin
    btnGetList.Visible := TRUE;
    btnGetList.Enabled := TRUE;
    btnDeleteActiveReason.Visible := TRUE;
    btnDeleteActiveReason.Enabled := TRUE;
    btnDeleteInactive.Visible := TRUE;
    btnDeleteInactive.Enabled := TRUE;
  end
  else
  begin
    btnGetList.Visible := FALSE;
    btnGetList.Enabled := FALSE;
    btnDeleteActiveReason.Visible := FALSE;
    btnDeleteActiveReason.Enabled := FALSE;
    btnDeleteInactive.Visible := FALSE;
    btnDeleteInactive.Enabled := FALSE;
  end;

end;


//------------------------------------------------------------------------------
// Initialization
//------------------------------------------------------------------------------
initialization
SpecifyFormIsNotADialog(TfrmEdtReRouteReasons);

end.
