unit ExceptionLogCapri;

interface
Uses
  ExceptionLog;

procedure CapriExceptionNotify(ExcRecord: TEurekaExceptionRecord; var Handled: Boolean);

implementation

procedure CapriExceptionNotify(ExcRecord: TEurekaExceptionRecord; var Handled: Boolean);
Var
  boSaveLogFile      : Boolean;
  boUseDelphiHandler : Boolean;
  sgUnitName         : String;
begin
  boSaveLogFile      := True;
  boUseDelphiHandler := True;
  sgUnitName         := ExcRecord.CallStack[0]^.UnitName;

  // Check for SourceCode information... 
  If
    (ExcRecord.CallStack[0]^.DebugDetail = ddSourceCode)
    and
    (ExcRecord.CallStack[0]^.UnitName = 'System.pas')
  Then
  Begin
    Handled := Not boUseDelphiHandler;
  End;

  // Show exception dialog?
  //ExcRecord.CurrentModuleOptions.ShowExceptionDialog :=
  //  MessageBox(0, 'Do you want to show error details?', 'Question',
  //    MB_YESNO or MB_ICONQUESTION or MB_TASKMODAL)=ID_YES;

  // save the Log File...
  ExcRecord.CurrentModuleOptions.SaveLogFile := boSaveLogFile;
  
  
end; 


end.
