unit XmlConfig;

interface

uses Classes;

type
  TXmlConfig = class
    const
      NAMESPACE_PREFIX = 'NAMESPACE_PREFIX';
      NAMESPACE = 'NAMESPACE';
      VERSION = 'VERSION';
      ELEMENT_NAME = 'ELEMENT_NAME';
      ELEMENT_TYPE = 'ELEMENT_TYPE';
      DOCUMENT_TITLE_TEXT = 'DOCUMENT_TITLE_TEXT';
      FILE_EXTENSION = '.pnl.xmlconfig';
    private
      config: TStringList;
    public
      function GetValue(key: String): String;
      procedure SetValue(key: String; stringValue: String);
      function GetConfig: TStringList;
    published
      constructor Create(theConfig: TStringList);
      destructor Destroy; override;

  end;

implementation

  constructor TXmlConfig.Create(theConfig: TStringList);
  begin
    if theConfig = nil then
      config := TStringList.Create
    else
      config := theConfig;
  end;

  destructor TXmlConfig.Destroy;
  begin
    if config <> nil then
      config.Free;

    inherited;    
  end;

  function TXmlConfig.GetValue(key: string): String;
  begin
    Result := config.Values[key];
  end;

  procedure TXmlConfig.SetValue(key: string; stringValue: string);
  begin
    config.Values[key] := stringValue;
  end;

  function TXmlConfig.GetConfig: TStringList;
  begin
    Result := config;
  end;

end.
