unit XsdEngineLite;

interface

uses Classes, XsdComplexType;

type
  TXsdEngineLite = class
    const
      FILE_EXTENSION = '.pnl.map';
    private
      xmlMapping: TStringList;
    public
      function ContainsComponent(componentName: String): Boolean;
      function GetXsdComplexType(componentName: String): TXsdComplexType;
    published
      constructor Create(theXmlMapping: TStringList);
  end;

implementation

  constructor TXsdEngineLite.Create(theXmlMapping: TStringList);
  begin
    xmlMapping := theXmlMapping;
  end;

  function TXsdEngineLite.ContainsComponent(componentName: string): Boolean;
  begin
    Result := False;

    if xmlMapping = Nil then
      Exit;

    if  Length(xmlMapping.Values[componentName]) > 0 then
      Result := True;
  end;

  function TXsdEngineLite.GetXsdComplexType(componentName: string): TXsdComplexType;
  var
    complexType: TXsdComplexType;
  begin
    if ContainsComponent(componentName) = False then
    begin
      Result := Nil;
      Exit;
    end;

    complexType := TXsdComplexType.Create(xmlMapping.Values[componentName]);

    Result := complexType;    
  end;

end.
