unit frmContractedExamNewResend;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, frmContractedBase, StdCtrls, CheckLst, Fmcntrls, clsPatientInfo,
  CCOWRPCBrokerCAPRI,                                                           // DONE: CodeCR457 - LMS Changed from CCOWRPCBroker
  Diaccess, Fmcmpnts, StrUtils, untMiscMthds, TRpcb,
  MFunStr, untAddtnlMMthds, ExtCtrls, DiTypLib, untConstVals,
  // DONE: CodeCR457 - LMS Removed, unused unit  untRequestXMLTmplte,
  dialogsCAPRI, clsUserInfo, untBrkrMthds,
  RequestXMLTmplte,
  XMLTemplate_CapriExamRequest,
  { Remote SFTP Class to Access Vendors SFTP Site }
  { Dialog for Retrieving Fee Authorization Number for Exams }
  dlgFeeAuth, ComCtrls
  , XMLIntf
  ;

type
  TExntdCntrctdBaseFormNewRsnd = class(TCntrctdBaseForm)
    grpbxCntrctr: TGroupBox;
    lblCmbBxCntrctr: TLabel;
    lblMemoCntrctrRmrks: TLabel;
    fmCmbBxContractor: TFMComboBox;
    fmMemoCntrctrRqstRmrks: TFMMemo;
    fmGetsVAMCInfo: TFMGets;
    Panel1: TPanel;
    cmbxContractor: TComboBox;
    Panel2: TPanel;
    fmFindOneTemp: TFMFindOne;
    fmGetsTemp: TFMGets;
    lblMultVendorWarning: TLabel;
    lblCFldrRqd: TStaticText;
    FMFiler1: TFMFiler;
    FMGets1: TFMGets;
    procedure FormShow(Sender: TObject);
    procedure fmCmbBxContractorKeyPress(Sender: TObject; var Key: Char);
    procedure chkBxCntrctAllExamsClick(Sender: TObject);
    procedure fmMemoCntrctrRqstRmrksChange(Sender: TObject);
    procedure fmCmbBxContractorChange(Sender: TObject);
    procedure chkdLstBxExamsClickCheck(Sender: TObject);
    procedure fmCmbBx2507RqstsChange(Sender: TObject);
    procedure cmbxContractorChange(Sender: TObject);
    procedure UploadFakeResults(Rcon, FirstIDN: String; Brkr: TCCOWRPCBrokerCAPRI);
    procedure cmbx2507RqstsChange(Sender: TObject);
    procedure btnRfrshRqstsClick(Sender: TObject);
    procedure fmMemoCntrctrRqstRmrksEnter(Sender: TObject);
    function SetRemarks(examien: String): Boolean;
  protected
    { Protected declarations }
    procedure ExecuteBtnAction; override;
    procedure PopExamList(rqstIEN: String); override;
  private
    { Private declarations }
    _AllExamsChecked: Boolean;
    _RsndExmInfo, _InsuffRqstSts: Boolean;
    _SlctdExamList: TStringList;
    // FsftpXMLRequest: IXMLREQUESTType;  { UNICODED String }
    // FXMLRequest: IXMLNode;  { UNICODED String }
    function AllExamsScheduled(): Boolean;
    function CheckOutExams(): Boolean;
    function ContractorsExist(): Boolean;
    procedure AllowAction;                                                      { ReSend or Check Out Processing }
    procedure CreateAndSendContractorMsg;
    procedure GetContractorResendableExams;
    procedure PopContractorsListWResendableRequests;
    procedure SetPatientInfoInSftpXML(AXMLRequest: IXMLREQUESTType);
    procedure SetPatientInfoInVlerXML(AXMLRequest: IXMLCapriExamRequest);
    procedure SetSftpVAMCInfo(FsftpXMLRequest: IXMLREQUESTType);
    procedure SetVlerVAMCInfo(FvlerXMLRequest: IXMLCapriExamRequest);
    procedure TransmitXMLMessage(XMLRqstFile: String; MainRCon: string; VLEREnabled: Boolean);
    function CreateSftpXML(feeAuthText: String; MainRCon: string): IXMLNode;
    function CreateVLERXML(feeAuthText: String; MainRCon: string): IXMLNode;

    function GenerateSftpFileName: string;
    function GenerateVLERFileName: string;
    function GetSetRequestUUID(reqNmbr: string): string;
    function SendCntrctrRemarksToVista: Boolean;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; PtntInfo: TPatientInfo;
      CCOWBrkr: TCCOWRPCBrokerCAPRI; TmrVal: Cardinal; RsndExmInfo: Boolean = False); reintroduce;
    destructor Destroy; override;
  end;

var
  ExntdCntrctdBaseFormNewRsnd: TExntdCntrctdBaseFormNewRsnd;

implementation

uses
  demTranMain
  , clsVendConn
  , clsSFTPConn
  , clsVLERConn
  , VlerDasClient
  , VA508AccessibilityRouter                                                    // rpk 10/17/2014
  , CAPRISupport                                                                // rpk 6/4/2015
  , main
  ;

{$R *.dfm}

constructor TExntdCntrctdBaseFormNewRsnd.Create(AOwner: TComponent; PtntInfo: TPatientInfo;
  CCOWBrkr: TCCOWRPCBrokerCAPRI; TmrVal: Cardinal; RsndExmInfo: Boolean = False);
begin
  inherited Create(AOwner, PtntInfo, CCOWBrkr, TmrVal);
  _AllExamsChecked := True;
  _RsndExmInfo := RsndExmInfo;                                                  { Form serves dual purposes }
  _SlctdExamList := TStringList.Create;
  fmGetsVAMCInfo.RPCBroker := CCOWBrkr;
  fmFindOneTemp.RPCBroker := CCOWBrkr;
  fmGetsTemp.RPCBroker := CCOWBrkr;
  { Throw Exception if no Contractors Exist }
  if Not ContractorsExist then
    raise ECntrctdExmError.Create('There are no active contractors defined to send exams to.' +
      #13#10 + 'Consult your local demTRAN Administrator or IRM for adding 2507 Exam Contractors.');
end;

destructor TExntdCntrctdBaseFormNewRsnd.Destroy;
begin
  _SlctdExamList.Free;
  inherited;

end;

function TExntdCntrctdBaseFormNewRsnd.GenerateSftpFileName(): string;
var
  fleNme: string;
  CCRTempDir: string;
begin
  { End Inner Try/Except Block for Date Formatting }
  CCRTempDir := GetTempExmDir(IntCCOWBrkrRef.User.DUZ);
  // DONE: LMS - refactored
  { End If Directory does not exists }
  fleNme := 'VAExamAuth';
  { Partial File Name - minus extension }
  if _InsuffRqstSts then
    fleNme := 'VAExamInsufficient';
  { Partial File Name - minus extension }
  { Complete File Names that will ultimately be attached to the message }
  Result := CCRTempDir + '\' + _PtntInfo.PatientName[1] + copy(_PtntInfo.PatientSSN, 5, 4) + fleNme + '-' + FormattedTimeStamp(Now) + '.XML';
end;

function TExntdCntrctdBaseFormNewRsnd.GenerateVLERFileName: string;
var
  fleNme: string;
  CCRTempDir: string;
begin
  CCRTempDir := GetTempExmDir(IntCCOWBrkrRef.User.DUZ);
  fleNme := 'VAExamAuth';
  if _InsuffRqstSts then
    fleNme := 'VAExamInsufficient';
  { Complete File Names that will ultimately be attached to the message }
  //Result := CCRTempDir + '\' + _PtntInfo.PatientName[1] + Piece(_PtntInfo.GetExternalSSN, '-', 3) + fleNme + '-' + FormattedTimeStamp(Now) + '.XML';
  Result := CCRTempDir + '\' + _PtntInfo.PatientName[1] + copy(_PtntInfo.PatientSSN, 5, 4) + fleNme + '-' + FormattedTimeStamp(Now) + '.XML';
end;

function TExntdCntrctdBaseFormNewRsnd.CreateSftpXML(feeAuthText: String; MainRCon: string): IXMLNode;
var
  FirstIDN: string;
  i: Integer;
  siteNmbr: string;
  reqNmbr: string;
  examTypeIEN: string;
  reqDate: string;
  examIEN: string;
  Con: string;
  Rcon: string;
  rqstDte: string;
  FsftpXMLRequest: IXMLREQUESTType;                                             { UNICODED String }
begin
  FsftpXMLRequest := NewREQUEST;
  {  Initialize XML Object }
  try
    rqstDte := FormatDateTime('mm/dd/yyyy', VarToDateTime(Piece(fmCmbBx2507Rqsts.GetSelectedRecord.GetField('1').FMDBExternal, '@')));
  except
    rqstDte := 'Unknown (Error Converting Value)';
  end;
  // DONE: LMS Files can get overwritten for same patient on SFTP servers, even if it's a different exam. So adding current timestamp. Not an issue with VLER.

  { Add requesting Regional Office}
  FsftpXMLRequest.DATE := rqstDte;
  { Request Date - when it was entered }
  FsftpXMLRequest.REGIONAL_OFFICE := fmCmbBx2507Rqsts.GetSelectedRecord.GetField('2').FMDBExternal;
  SetSftpVAMCInfo(FsftpXMLRequest);
  { Add VAMC making Request to XML Request Message }
  SetPatientInfoInSftpXML(FsftpXMLRequest);
  { Add Patient Info to XML Request Message }
  { Add Notation on whether Claim Folder Required }
  FsftpXMLRequest.CLAIM_FOLDER_REQ := UpperCase(fmCmbBx2507Rqsts.GetSelectedRecord.GetField('21').FMDBExternal);
  FirstIDN := '';
  { Add selected exams for contractor to fulfill to message body }
  for i := 0 to _SlctdExamList.Count - 1 do
  begin
    with FsftpXMLRequest.EXAMS.Add do
    begin
      // insert here gbh / jltp
      ExamName := Trim(_SlctdExamList[i]);
      siteNmbr := FsftpXMLRequest.MEDICAL_CENTER.SITENUMBER;
      reqNmbr := fmCmbBx2507Rqsts.GetSelectedRecord.IEN;
      fmFindOneTemp.FileNumber := '396.6';
      fmFindOneTemp.Screen := 'I $P(^(0),U,5)="A"';
      fmFindOneTemp.FMIndex := 'B';
      fmFindOneTemp.Value := ExamName;
      examTypeIEN := fmFindOneTemp.GetIEN;
      fmGetsTemp.FileNumber := '396.3';
      fmGetsTemp.AddField('1');
      fmGetsTemp.IENS := reqNmbr;
      fmGetsTemp.GetData;
      reqDate := fmGetsTemp.GetField('1').FMDBExternal;
      fmFindOneTemp.FileNumber := '396.4';
      fmFindOneTemp.Screen := 'I $P(^(0),U,3)=' + examTypeIEN + ',$P(^(0),U,2)=' + reqNmbr;
      fmFindOneTemp.FMIndex := 'C';
      fmFindOneTemp.Value := reqDate;
      examIEN := fmFindOneTemp.GetIEN;
      fmGetsTemp.RemoveField('1');
      fmGetsTemp.FileNumber := '396.4';
      fmGetsTemp.AddField('100');
      fmGetsTemp.IENS := examIEN;
      fmGetsTemp.GetData;
      Con := fmGetsTemp.GetField('100').FMDBInternal;
      fmGetsTemp.RemoveField('100');

      fmGetsTemp.FileNumber := '396.45';
      fmGetsTemp.AddField('3');
      fmGetsTemp.IENS := Con;
      fmGetsTemp.GetData;
      Rcon := fmGetsTemp.GetField('3').FMDBInternal;
      // DONE: LMS temporary fix ensuring an exam with multiple
      //           contractors, is not allowed to "resend" since it will fail to send a part to one vendor.
      if MainRCon <> Rcon then
      begin
        //raise exception.create('Can not resend a request that has been sent to multiple contractors in this version');
        lblMultVendorWarning.Visible := True;
      end;
      ExamID := siteNmbr + '-' + reqNmbr + '-' + examIEN;
      if (i = 0) then
        FirstIDN := ExamID;
    end;
  end;
  { End Exam For Loop }
  { Add Request Remarks to XML Request Message }
  for i := 0 to fmMemoCntrctrRqstRmrks.Lines.Count - 1 do
  begin
    if (i = 0) then
      FsftpXMLRequest.REMARKS := FsftpXMLRequest.REMARKS + fmMemoCntrctrRqstRmrks.Lines[i]
    else
{(*}
      FsftpXMLRequest.REMARKS := FsftpXMLRequest.REMARKS + ''#13''#10'' + fmMemoCntrctrRqstRmrks.Lines[i];
{*)}
  end;
  { End Remarks For Loop }
  { Add Fee Authorization Number to XML Request Message if known by User }
  FsftpXMLRequest.FEEAUTHORIZATION := feeAuthText;
  Result := FsftpXMLRequest;
end;

function TExntdCntrctdBaseFormNewRsnd.GetSetRequestUUID(reqNmbr: string): string;
var
  ReqFiler: TFMFiler;
begin
  fmGetsTemp.FileNumber := '396.3';
  fmGetsTemp.AddField('46');
  fmGetsTemp.IENS := reqNmbr;
  fmGetsTemp.GetData;
  Result := fmGetsTemp.GetField('46').FMDBExternal;
  if Result = '' then
  begin
    Result := GetStringGUID;
    ReqFiler := TFMFiler.Create(self);
    try
      ReqFiler.RPCBroker := fmGetsTemp.RPCBroker;
      ReqFiler.FilerFlags := [ffLock];
      ReqFiler.FilerOptions := [foProcessProblemList];
      try
        ReqFiler.AddFDA('396.3', reqNmbr, '46', Result);
        if not ReqFiler.Update then begin                                       // rare possibilty but put the error in the result so it gets manually caught in case user ignores the message.
          Result := 'Error in setting Request UUID for Request: ' + reqNmbr;
          ReqFiler.DisplayErrors;
        end;
      except
      end;
    finally
      ReqFiler.Free;
    end;
  end;
end;

function TExntdCntrctdBaseFormNewRsnd.CreateVLERXML(feeAuthText, MainRCon: string): IXMLNode;
var
  FirstIDN: string;
  i: Integer;
  siteNmbr: string;
  reqNmbr: string;
  examTypeIEN: string;
  reqDate: string;
  examIEN: string;
  Con: string;
  Rcon: string;
  rqstDte: string;
  FvlerXMLRequest: IXMLCapriExamRequest;                                        { UNICODED String }
//  AUid: TGuid;
begin
  {  Initialize XML Object }
  FvlerXMLRequest := NewCapriExamRequest;

  FvlerXMLRequest.RequestStatus := 'Open';

  FvlerXMLRequest.PhysicalSource := TfrmCntrctdExmMain(Owner).GetContractorName(MainRCon); // LMS: An example of how not to reference demTranMain instance of the form directly. If all CAPRI was coded like this, it would be MUCH more "object oriented" and we could move things around in the app easier. Now everything is locked down!!

  { Request Date - when it was entered }
  try
    rqstDte := FormatDateTime('yyyy-mm-dd', VarToDateTime(Piece(fmCmbBx2507Rqsts.GetSelectedRecord.GetField('1').FMDBExternal, '@')));
  except
    rqstDte := '1890-01-01';                                                    // erroneous date
  end;
  FvlerXMLRequest.RequestDate := rqstDte;

  { Add requesting Regional Office}
  FvlerXMLRequest.RegionalOffice := fmCmbBx2507Rqsts.GetSelectedRecord.GetField('2').FMDBExternal;

  { Add VAMC making Request to XML Request Message }
  SetVlerVAMCInfo(FvlerXMLRequest);

  { Add Patient Info to XML Request Message }
  SetPatientInfoInVlerXML(FvlerXMLRequest);

  { Add Notation on whether Claim Folder Required }
  FvlerXMLRequest.ClaimFolderRequired := (UpperCase(fmCmbBx2507Rqsts.GetSelectedRecord.GetField('21').FMDBExternal) = 'YES'); // done: LMS should it be 'y' or 'yes'
  FirstIDN := '';
  { Add selected exams for contractor to fulfill to message body }
  for i := 0 to _SlctdExamList.Count - 1 do
  begin
    with FvlerXMLRequest.EXAMS.Add do
    begin
      // insert here gbh / jltp
      ExamName := Trim(_SlctdExamList[i]);
      siteNmbr := FvlerXMLRequest.MedicalCenter.SiteNumber.Value;
      reqNmbr := fmCmbBx2507Rqsts.GetSelectedRecord.IEN;

      fmFindOneTemp.FileNumber := '396.6';
      fmFindOneTemp.Screen := 'I $P(^(0),U,5)="A"';
      fmFindOneTemp.FMIndex := 'B';
      fmFindOneTemp.Value := ExamName;
      examTypeIEN := fmFindOneTemp.GetIEN;

      fmGetsTemp.FileNumber := '396.3';
      fmGetsTemp.AddField('1');
      fmGetsTemp.IENS := reqNmbr;
      fmGetsTemp.GetData;
      reqDate := fmGetsTemp.GetField('1').FMDBExternal;

      fmFindOneTemp.FileNumber := '396.4';
      fmFindOneTemp.Screen := 'I $P(^(0),U,3)=' + examTypeIEN + ',$P(^(0),U,2)=' + reqNmbr;
      fmFindOneTemp.FMIndex := 'C';
      fmFindOneTemp.Value := reqDate;
      examIEN := fmFindOneTemp.GetIEN;

      fmGetsTemp.RemoveField('1');
      fmGetsTemp.FileNumber := '396.4';
      fmGetsTemp.AddField('100');
      fmGetsTemp.IENS := examIEN;
      fmGetsTemp.GetData;
      Con := fmGetsTemp.GetField('100').FMDBInternal;
      fmGetsTemp.RemoveField('100');

      fmGetsTemp.FileNumber := '396.45';
      fmGetsTemp.AddField('3');
      fmGetsTemp.IENS := Con;
      fmGetsTemp.GetData;
      Rcon := fmGetsTemp.GetField('3').FMDBInternal;

      // DONE: LMS temporary fix ensuring an exam with multiple
      //           contractors, is not allowed to "resend" since it will fail to send a part to one vendor.
      if MainRCon <> Rcon then
      begin
        //raise exception.create('Can not resend a request that has been sent to multiple contractors in this version');
        lblMultVendorWarning.Visible := True;                                   // TODO: LMS make sure the calls succeed if this warning is shown
      end;
      ExamID := siteNmbr + '-' + reqNmbr + '-' + examIEN;
      if (i = 0) then
        FirstIDN := ExamID;
    end;
  end;
  { End Exam For Loop }

  FvlerXMLRequest.RequestId := GetSetRequestUUID(reqNmbr);                      //   // DONE: LMS this needs to go to vista for the request (or should be pulled from there if already filled in file 396.3, field 46

  { Add Request Remarks to XML Request Message }
  for i := 0 to fmMemoCntrctrRqstRmrks.Lines.Count - 1 do
  begin
    if (i = 0) then
      FvlerXMLRequest.REMARKS := FvlerXMLRequest.REMARKS + fmMemoCntrctrRqstRmrks.Lines[i]
    else
{(*}
      FvlerXMLRequest.REMARKS := FvlerXMLRequest.REMARKS + ''#13''#10'' + fmMemoCntrctrRqstRmrks.Lines[i];
{*)}
  end;
  { End Remarks For Loop }
  { Add Fee Authorization Number to XML Request Message if known by User }
  FvlerXMLRequest.FEEAUTHORIZATION := feeAuthText;
  Result := FvlerXMLRequest;
end;                                                                            // CreateVLERXML

procedure TExntdCntrctdBaseFormNewRsnd.chkBxCntrctAllExamsClick(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to chkdLstBxExams.Items.Count - 1 do
    if (chkdLstBxExams.ItemEnabled[i]) then chkdLstBxExams.Checked[i] := true;

  inherited;
  if Not _RsndExmInfo then
    AllowAction;
end;

procedure TExntdCntrctdBaseFormNewRsnd.chkdLstBxExamsClickCheck(Sender: TObject);
begin
  inherited;
  if Not _RsndExmInfo then
    AllowAction;
end;

procedure TExntdCntrctdBaseFormNewRsnd.cmbx2507RqstsChange(Sender: TObject);
begin
  inherited;

  // DONE: LMS the combo box was changing but the hidden fmComboBox wasn't aware of the change.
  //application.processmessages();
  fmCmbBx2507RqstsChange(Sender);                                               // DONE: LMS Claim folder flag is not refreshing.
end;

procedure TExntdCntrctdBaseFormNewRsnd.cmbxContractorChange(Sender: TObject);
begin
  { Keep Comboboxes in Sync - for 508 Compatibility }
  fmCmbBxContractor.ItemIndex := cmbxContractor.ItemIndex;
  fmCmbBxContractorChange(Sender);
  if (cmbxContractor.ItemIndex >= 0) then                                       { Ensure Contractor Selected & NOT Cleared }
    { Check-Out will only be allowed if Contractor is associated with Remote SFTP Entry }
    if (StrToIntDef(fmLstrCntrctrs.GetRecord(fmCmbBxContractor.GetSelectedRecord.IEN)
      .GetField('3').FMDBExternal, 0) = 0) then
      Application.MessageBox(PChar('The selected contractor (' + cmbxContractor.Text +
        ') is NOT associated with a Remote SFTP entry for connection to the Vendors ' +
        'system.' + #13#10 + 'Edit the contractor information ' +
        '(AdminTools - Add/Edit Contractors) to include a Remote SFTP entry.'),
        'Missing Remote Connection', MB_OK);
  ResetWndwTmr;
end;

procedure TExntdCntrctdBaseFormNewRsnd.fmCmbBx2507RqstsChange(Sender: TObject);
begin
  if (Sender <> btnRfrshRqsts) then
    inherited;                                                                  { Prevent's Repopulating Exam List during request refresh }
  _InsuffRqstSts := False;
  { Indicate whether Claims Folder required to be sent for selected request }
  If SameText(UpperCase(fmCmbBx2507Rqsts.GetSelectedRecord.
    GetField('21').FMDBExternal), 'YES') then
    lblCFldrRqd.Caption := '* Claim Folder Required'
  else
    lblCFldrRqd.Caption := '* Claim Folder NOT Required';
  { Check to see if Insufficient Exam Request - Internal Value Requested }
  if SameText(UpperCase(fmCmbBx2507Rqsts.GetSelectedRecord.GetField('9').
    FMDBExternal), 'E') then
    _InsuffRqstSts := True;
  AllowAction;                                                                  { Override Base Method value if needed because of additional constraints }
end;

procedure TExntdCntrctdBaseFormNewRsnd.fmCmbBxContractorChange(Sender: TObject);
begin
  ResetWndwTmr;
  AllowAction;
end;

procedure TExntdCntrctdBaseFormNewRsnd.fmCmbBxContractorKeyPress(
  Sender: TObject; var Key: Char);
begin
  ResetWndwTmr;
  Key := #0;                                                                    { Prevent Key Events, as style cannot be changed to dropdownlist }
end;

procedure TExntdCntrctdBaseFormNewRsnd.fmMemoCntrctrRqstRmrksChange(
  Sender: TObject);
begin
  ResetWndwTmr;
  AllowAction;
end;

procedure TExntdCntrctdBaseFormNewRsnd.fmMemoCntrctrRqstRmrksEnter(
  Sender: TObject);
begin
  inherited;
  fmMemoCntrctrRqstRmrks.SelStart := 0; // rpk 7/7/2015
  GetScreenReader.Speak(fmMemoCntrctrRqstRmrks.Lines.Text);                     // rpk 10/17/2014
end;

procedure TExntdCntrctdBaseFormNewRsnd.FormShow(Sender: TObject);
var
  strVal: String;
begin
  inherited;
  strVal := 'New ';
  if _RsndExmInfo then
  begin
    strVal := 'Resend ';
    btnAction.Caption := 'R&esend';
  end;                                                                          { End If Form Setup is to Resend Info to Contractor }
  Caption := strVal + 'Contracted 2507 Exam(s) for ' + _PtntInfo.PatientName +
    ' (' + Copy(_PtntInfo.PatientSSN, Length(_PtntInfo.PatientSSN) - 3, 4) + ')';
  btnRfrshRqstsClick(self);                                                     { Populate Requests }
end;

procedure TExntdCntrctdBaseFormNewRsnd.ExecuteBtnAction;
var
  ProdAccnt: Boolean;
begin
  ResetWndwTmr;
  if (cmbxContractor.ItemIndex >= 0) then
  begin
    ProdAccnt := IsProductionAccount(IntCCOWBrkrRef);                           { Determine Account }
    { Disable Check-Out Processing for Test Accounts, Unless Development
      Test Account and user holds the Test Key: ZJFW CONTRACTED EXM TEST }
    if (ProdAccnt or ((Not ProdAccnt) and
      TUserInfo.UserHasKey(IntCCOWBrkrRef, 'ZJFW CONTRACTED EXM TEST'))) then
    begin
      Forms.Screen.Cursor := crHourGlass;
      try
        if _RsndExmInfo then
        begin
          GetContractorResendableExams;                                         { Get Exams to be sent to selected Contractor }
          CreateAndSendContractorMsg;                                           { Send Contractor EMail Message Only }
        end                                                                     { End If Resend Process }
        else
        begin
          { Add Contractor and Check-Out Date/Time (Current Date/Time used) to each
            2507 Exam that is being externally contracted out. }
          if CheckOutExams then
            CreateAndSendContractorMsg                                          { Send Contractor EMail Message }
          else                                                                  { Display Err Message to User - Previous Changes Backed Out in VistA }
            MessageDlgCAPRI('An error occurred while updating Exam entries with contract info.' +
              #13#10 + 'All exams previously selected have been returned to their original state.'
              + #13#10 + 'Please try again later, if the problem persists consult IRM.',
              mtError, [mbOK], 0);
        end;                                                                    { End Else Check-Out Action }
      finally
        ModalResult := mrOk;                                                    { Close Window }
        Forms.Screen.Cursor := crDefault;
      end;                                                                      { End Try/Finally Block }
    end                                                                         { End Production Account or Dev Test Account & User has Key }
    else
      MessageDlgCAPRI('This functionality has been disabled on TEST accounts,' + #13#10 +
        'since the Broker Security Enhancements (BSE) used to reverse' + #13#10 +
        'lookup the Vendors SFTP information on CLAIMS is not readily supported.',
        mtWarning, [mbOK], 0);
  end                                                                           { End If Contractor Selected }
  else
  begin                                                                         { Users didn't want contractor initially selected (Ie. No Default) }
    MessageDlgCAPRI('No contractor was selected to send exam(s) too.' +
      #13#10 + 'Please select a contractor to continue.',
      mtError, [mbOK], 0);
    cmbxContractor.SetFocus;
  end;                                                                          { End Else If NO Contractor Selected }
end;
   // gbh here

procedure TExntdCntrctdBaseFormNewRsnd.PopExamList(rqstIEN: string);
var
  i: Integer;
  IEN, exmSts, cntrctrIEN, cntrctrNme: String;
begin
  chkdLstBxExams.Items.BeginUpdate;
  { Add Exams for Request to list, disable entries that are Cancelled,
    Transferred Out, Completed or have already been CheckedIn/Out To Contractor }
  for i := 0 to _fmTmpLstrExams.Results.Count - 1 do
  begin
    IEN := _fmTmpLstrExams.Results[i];
    exmSts := _fmTmpLstrExams.GetRecord(IEN).GetField('.04').FMDBExternal;
    { Internal value requested in lister call, but value still returned in External }
    cntrctrIEN := _fmTmpLstrExams.GetRecord(IEN).GetField('100').FMDBExternal;
    cntrctrNme := '';
    if Not SameText(cntrctrIEN, '') then
      cntrctrNme := ' - ' + fmLstrCntrctrs.GetRecord(cntrctrIEN).GetField('.01').FMDBExternal;
    { Add Exam Info for Request to List }
    chkdLstBxExams.Items.AddObject(_fmTmpLstrExams.GetRecord(IEN).GetField
      ('.03').FMDBExternal + ' [' + exmSts + cntrctrNme + ']', TObject(StrToInt(IEN)));
    { Show all Exams for request, but Disable Exam entries in list if resending
      exams to contractor, or if not resending exams and the exam has been
      canceled (By MAS or RO), transferred out, completed or has been already
      Checked In/Out to Contractor }
    if (_RsndExmInfo or (Not SameText(UpperCase(exmSts), 'OPEN')) or
      (Not SameText(_fmTmpLstrExams.GetRecord(IEN).GetField('101')
      .FMDBExternal, '')) or (Not SameText(_fmTmpLstrExams.GetRecord(IEN)
      .GetField('102').FMDBExternal, ''))) then
    begin
      chkdLstBxExams.ItemEnabled[(chkdLstBxExams.Items.Count - 1)] := False;
      if (_RsndExmInfo and (Not SameText(_fmTmpLstrExams.GetRecord(IEN).GetField
        ('101').FMDBExternal, '')) and
        (SameText(_fmTmpLstrExams.GetRecord(IEN).GetField('102')
        .FMDBExternal, ''))) then
      begin
        chkdLstBxExams.Checked[(chkdLstBxExams.Items.Count - 1)] := True;
        { Add to Resend list if checked-out - user hash style to throw out duplicates }
        _RqstCntrctrs.Values[Mfunstr.Piece(cntrctrNme, '- ', 2) + '^' + cntrctrIEN] := cntrctrIEN;
      end;                                                                      { End If Checking Applicable Exam Items for display to user when resending }
    end                                                                         { End If Disable Exams }
    else
      chkBxCntrctAllExams.Enabled := True;                                      { If at least one exam is available }
  end;                                                                          { End For Loop }
  chkdLstBxExams.Items.EndUpdate;
  chkdLstBxExams.Repaint;
  if (_RsndExmInfo) then
    PopContractorsListWResendableRequests
  else
  begin
    cmbxContractor.ItemIndex := -1;
    cmbxContractorChange(self);
    { Enable Contractor Selection only if at least 1 exam availble }
    cmbxContractor.Enabled := chkBxCntrctAllExams.Enabled;
  end;                                                                          { End Else Check Out Processing }
  { Get 2507 Request Remarks for user to edit, appended to end of Contractor Email }

  _2507Info.Get2507WPInfo('396.3', '23', rqstIEN, fmMemoCntrctrRqstRmrks);

  AllowAction;
end;                                                                            // PopExamList

{ PRIVATE }

function TExntdCntrctdBaseFormNewRsnd.ContractorsExist(): Boolean;
begin
  Result := False;
  { Retrieve Only Active Contractors for Selection }
  fmLstrCntrctrs.Results.Clear;
  fmCmbBxContractor.Text := '';
  fmCmbBxContractor.Items.Clear;
  cmbxContractor.Items.Clear;
  fmCmbBxContractor.GetList;                                                    { Populate Contractors }
  cmbxContractor.Items.AddStrings(fmCmbBxContractor.Items);
  if (fmCmbBxContractor.Items.Count > 0) then
  begin
    { Retrieve all contractors as contractors still assigned exams may have
      been subsequently inactivated. }
    GetContractors;                                                             { Retrieve List of Contractors in File #396.45 }
    Result := True;
  end;                                                                          { End If Contractors Exist in File }
end;

procedure TExntdCntrctdBaseFormNewRsnd.PopContractorsListWResendableRequests;
var
  i: Integer;
  RecObj: TFMRecordObj;
begin
  ResetWndwTmr;
  _RqstCntrctrs.Sort;                                                           { Sort List Alphabetically }
  { Pop list with only contractors that have been assigned an exam on the
    request, which has NOT already been checked-out. }
  fmCmbBxContractor.Items.Clear;
  cmbxContractor.Items.Clear;                                                   { For 508 Compatibility }
  cmbxContractor.Enabled := (_RqstCntrctrs.Count > 0);
  if (_RqstCntrctrs.Count > 0) then
  begin
    for i := 0 to _RqstCntrctrs.Count - 1 do
    begin
      RecObj := TFMRecordObj.Create;                                            { Mimic FM info storage }
      RecObj.IEN := Piece(Piece(_RqstCntrctrs[i], '^', 2), '=');
      fmCmbBxContractor.Items.AddObject(Piece(_RqstCntrctrs[i], '^'), RecObj);
      cmbxContractor.Items.AddObject(Piece(_RqstCntrctrs[i], '^'), RecObj);
    end;                                                                        { End Request Contractors Loop }
    cmbxContractor.ItemIndex := 0;
    cmbxContractorChange(self);
  end;                                                                          { End If Contractors Exist in List }
  { Disable Contractor Selection if No Contractors available }
  cmbxContractor.Enabled := (cmbxContractor.Items.Count > 0);
end;

procedure TExntdCntrctdBaseFormNewRsnd.GetContractorResendableExams;
var
  i: Integer;
  exmIEN: String;
begin
  i := -1;
  _SlctdExamList.Clear;
  { All Resendable exams are checked in list - find exams for slctd contractor }
  repeat
    inc(i);
    if chkdLstBxExams.Checked[i] then
    begin
      exmIEN := IntToStr(Integer(chkdLstBxExams.Items.Objects[i]));
        { Add Exams to List if for slctd contractor }
      if fmCmbBxContractor.GetSelectedRecord.IEN =
        _fmTmpLstrExams.GetRecord(exmIEN).GetField('100').FMDBExternal then
        _SlctdExamList.Add(Piece(chkdLstBxExams.Items[i], '['));
    end;                                                                        { End If Item enabled and is checked or all items checkbox is checked }
  until (i = (chkdLstBxExams.Items.Count - 1));
end;

procedure TExntdCntrctdBaseFormNewRsnd.AllowAction;
var
  enblBtn, RmtSFTPEntry: Boolean;
begin
  RmtSFTPEntry := False;
  { Allow resend action if Exam(s) exists for the selected contractor, the
    Exam Info to add to the XML Request is NOT blank and the Contractor has a
    Remote SFTP entry.
    Allow check-out action if Exam(s) selected, contractor selected, the
    Exam Info to add to the XML Request is NOT blank and the Contractor has a
    Remote SFTP entry. }
  { Ensure Contractor selected prior to checking for value }
  if (cmbxContractor.ItemIndex >= 0) then
    RmtSFTPEntry := (StrToIntDef(fmLstrCntrctrs.GetRecord(fmCmbBxContractor.GetSelectedRecord.IEN)
      .GetField('3').FMDBExternal, 0) > 0);
  if _RsndExmInfo then begin
    enblBtn := (GetCheckedOpenCount(chkdLstBxExams) > 0)                        // DONE: LMS Was erroneously allowing "cancelled" exams to be resent. Was also allowing multi vendor exams to be resent
      and ((cmbxContractor.Enabled) and (fmMemoCntrctrRqstRmrks.Lines.Count > 0) and
      RmtSFTPEntry);
    if enblBtn and (GetCheckedOpenOneVendorCount(chkdLstBxExams) = 0) then
    begin
      enblBtn := false;
      lblMultVendorWarning.Visible := true;
    end else
      lblMultVendorWarning.Visible := false;
  end
  else
    enblBtn := (((GetCheckedCount(chkdLstBxExams) > 0) or
      (chkBxCntrctAllExams.Checked)) and (fmMemoCntrctrRqstRmrks.Lines.Count > 0) and
      RmtSFTPEntry);
  btnAction.Enabled := enblBtn;
end;

procedure TExntdCntrctdBaseFormNewRsnd.btnRfrshRqstsClick(Sender: TObject);
begin
  inherited;
  fmCmbBx2507RqstsChange(Sender);                                               // DONE: LMS Claim folder flag is not refreshing.
end;

function TExntdCntrctdBaseFormNewRsnd.SetRemarks(examien: String): Boolean;
begin
  Result := False;
  if examien > '' then begin
    FMmemoCntrctrRqstRmrks.IENS := examIEN;
    FMFiler1.AddChgdControl(fmMemoCntrctrRqstRmrks);

    if FMFiler1.AnythingToFile then
      if FMFiler1.DataProblemCheck then begin
        FMFiler1.ProcessDataProblemList
      end
      else if FMFiler1.Update then begin
        Result := True;
      end
      else
        FMFiler1.DisplayErrors;
  end;

end;                                                                            // SetRemarks

function TExntdCntrctdBaseFormNewRsnd.SendCntrctrRemarksToVista: Boolean;       // CodeCR730 rpk 6/4/2015
var
  i, examcnt: Integer;
  ienslst: String;
  exmIEN, reqNmbr: String;
  bres: Boolean;
//const
//  CRLF = chr(13) + chr(10);
begin
  Result := False;
  // get list of exam ids
  ienslst := '';
  examcnt := 0;
  for I := 0 to chkdLstBxExams.Count - 1 do begin
    if chkdLstBxExams.Checked[i] or chkBxCntrctAllExams.Checked then begin
      exmIEN := IntToStr(Integer(chkdLstBxExams.Items.Objects[i]));
      ienslst := IfThen(i = 0, exmIEN, ienslst + U + exmIEN);
      Inc(examcnt);
    end;                                                                        //  End If Item enabled and is checked or all items checkbox is checked
  end;

  // exam request id
  reqNmbr := fmCmbBx2507Rqsts.GetSelectedRecord.IEN;

  // send contractor remarks to vista for later retrieval in managereportsCCR; CodeCR730 rpk 6/5/2015
  if Length(ienslst) > 0 then begin
    try
      bres := CallRPC(frmMain.RPCBroker1, 'DVBA CAPRI SETCONTREMARKS',
        [reqNmbr, ienslst], fmMemoCntrctrRqstRmrks.Lines);
      { showmessage('CallRPC DVBA CAPRI SETCONTREMARKS;' + CRLF +
        'request number=' + reqNmbr + CRLF +
        'exam iens=' + ienslst + CRLF +
        'Remarks=' + CRLF + '"' + fmMemoCntrctrRqstRmrks.Lines.Text + '"'); }
    except
      { showmessage('EXCEPTION: CallRPC DVBA CAPRI SETCONTREMARKS;' + CRLF +
        'request number=' + reqNmbr + CRLF +
        'exam iens=' + ienslst + CRLF +
        'Remarks=' + CRLF + '"' + fmMemoCntrctrRqstRmrks.Lines.Text + '"'); }
      bres := True;
      FMmemoCntrctrRqstRmrks.FMFile := '396.4';
      FMmemoCntrctrRqstRmrks.FMField := '103';

      Screen.Cursor := crHourglass;                                             // Show hourglass cursor
      for I := 1 to examcnt do begin
        exmien := MFunstr.Piece(ienslst, U, i);
        bres := bres and SetRemarks(exmien);
      end;
      Screen.Cursor := crDefault;

      FMmemoCntrctrRqstRmrks.FMFile := '396.3';
      FMmemoCntrctrRqstRmrks.FMField := '23';
//      bres := False;
//      raise;
    end;
  end;
  Result := bres;

end;                                                                            // SendCntrctrRemarksToVista

{ Create/Send XML Request Message with Exam Info to selected Vendor. }

procedure TExntdCntrctdBaseFormNewRsnd.CreateAndSendContractorMsg;
var
//  ExamName: String;
  xmlFile: String;
//  , ExamID: String;
  dlgFeeAuthRtrvl: TfrmFeeAuthDlg;
  feeAuthText: String;
  MainRCon: string;
  FXMLRequest: IXMLNode;
  VLEREnabled: Boolean;
  bres: Boolean;
begin
  MainRCon := fmLstrCntrctrs.GetRecord(fmCmbBxContractor.GetSelectedRecord.IEN).GetField('3').FMDBExternal;

  // send contractor remarks to vista for later use in managereportsccr
  bres := SendCntrctrRemarksToVista;                                            // CodeCR730 rpk 6/5/2015

{$IFNDEF CAPRIDEVELOPER}
  dlgFeeAuthRtrvl := TfrmFeeAuthDlg.Create(self);
  try
    dlgFeeAuthRtrvl.ShowModal;                                                  { Retrieve Fee Authorization if known }
    feeAuthText := dlgFeeAuthRtrvl.txtbxFeeAuthNum.Text;
  finally
    dlgFeeAuthRtrvl.Free;
  end;
{$ELSE}
  feeAuthText := 'Developer Test to: ' + TfrmCntrctdExmMain(Owner).GetContractorName(MainRCon);
{$ENDIF}

  VLEREnabled := TfrmCntrctdExmMain(Owner).IsContractorVLEREnabled(MainRCon);   // LMS: An example of how not to reference demTranMain instance of the form directly. If all CAPRI was coded like this, it would be MUCH more "object oriented" and we could move things around in the app easier. Now everything is locked down!!

  if VLEREnabled then begin
    xmlFile := GenerateVLERFileName();
    FXMLRequest := CreateVLERXML(feeAuthText, MainRCon);                        // todo: lms check if error raised
  end else begin
    xmlFile := GenerateSftpFileName();
    FXMLRequest := CreateSftpXML(feeAuthText, MainRCon);                        // todo: lms check if error raised
  end;

  try
    try
      FXMLRequest.OwnerDocument.SaveToFile(xmlFile);
      FormatXMLDoc(xmlFile);                                                    { Add Line Breaks and Indents to make readable }
      { Send Request XML to Vendor through Vendor's SFTP Connection maintained on CLAIMS, or via VLER }
      TransmitXMLMessage(xmlFile, MainRCon, VLEREnabled);
      // Temporary while testing - remove before production use -jltp 26-feb-2013
      // UploadFakeResults(Rcon, FirstIDN, _CCOWBrkr);  // TODO: LMS Can use during testing.
      // End temporary while testing -jltp  26-feb-2013
    except on E: Exception do                                                   { NOT EXPECTED }
        MessageDlgCAPRI('XML Request message for contractor could not be created.' + #13#10 +
          'Execute a "Re-Send" of the Exam(s) to the contractor to re-generate the XML Request Message again.',
          mtError, [mbOK], 0);
    end;                                                                        { End Try/Catch for XML Request Message File Creation }
  finally
    { $IFNDEF CAPRIDEVELOPER}
    // SysUtils.DeleteFile(xmlFile);  { Delete XML Request Message from Machine }
    { $ENDIF}
  end;                                                                          { End Outer Try/Finally Block }
end;                                                                            // CreateAndSendContractorMsg

procedure TExntdCntrctdBaseFormNewRsnd.TransmitXMLMessage(XMLRqstFile: String; MainRCon: string; VLEREnabled: Boolean);
var
  Connection: TVendorConnect;                                                   // TODO: LMS - wait - per one operation, all these methods should use one connection, as long as RCon doesn't change
  // Location1: string;
  sendMethod: string;
begin
  Connection := nil;
  { Already performed all checks prior to getting to this point:
       - Production Account or Test Account and User has Test Key: ZJFW CONTRACTED EXM TEST
       - Contractor has associated SFTP Entry on Remote CLAIMS/TESTCLAIMS System }
  // Location1 := fmCmbBxContractor.GetSelectedRecord.IEN;
  try
    try
      tmrWndwClose.Enabled := False;
      if FileExists(XMLRqstFile) then
      begin
        { Create SFTP Connection Object - Connects to CLAIMS/TESTCLAIMS to
          retrieve SFTP Credentials, Location, Path, etc... }
        // Location1 := 'Pre ' + _CCOWBrkr.CCOWLogonIDName + ' Create' + ' ' + Location1;
        // Location1 := fmLstrCntrctrs.GetRecord(fmCmbBxContractor.GetSelectedRecord.IEN).GetField('3').FMDBExternal  + ' ' + Location1;
        if VLEREnabled then begin
          Connection := TVLERConn.Create(MainRCon, False, IntCCOWBrkrRef);
          TVLERConn(Connection).UploadFile(XMLRqstFile);                        { Send File to Server }
        end else begin
          Connection := TSFTPConn.Create(MainRCon, False, IntCCOWBrkrRef);
          TSFTPConn(Connection).UploadFile(XMLRqstFile);                        { Send File to Server }
        end;
        //Location1 := 'Post ' + XMLRqstFile + ' Create';

      end;                                                                      { End If File Exists - Transmit only if file exists }
    except
      on E: Exception do
      begin
        sendMethod := 'SFTP server.';                                           // DONE: LMS - CodeCR568 change user message
        if VLEREnabled then
          sendMethod := 'VLER/DAS';
        Application.MessageBox(PChar('Error occurred uploading the XML Request ' + // TODO: LMS wait these should all switch to using CAPRI's error display dialogs/mechanisms
          'to the Vendor via ' + sendMethod + #13#10 +
             // 'Location: ' + Location1 + #13#10 +
          'Try Re-Sending the Exam(s) again later.' + #13#10 +
          'If the problem persists, contact the Help Desk for assistance.' +
          #13#10#13#10 + E.Message), 'Transmission Error', MB_OK);
      end;                                                                      { End Exception Handling Block }
    end;                                                                        { End Inner Try/Except Block }
  finally
    ResetWndwTmr;
    Connection.Free;
  end;                                                                          { End Outer Try/Finally Block }
end;

// used only for testing

procedure TExntdCntrctdBaseFormNewRsnd.UploadFakeResults(Rcon, FirstIDN: String; Brkr: TCCOWRPCBrokerCAPRI);
var
  Connection: TSFTPConn;
begin
  { try
    tmrWndwClose.Enabled := False;
    Connection := TSFTPConn.Create(Rcon, False, Brkr);
    Connection.Upld2DlDir(FirstIDN + '-Results.txt');
  finally
    ResetWndwTmr;
    Connection.Free;
  end; }
  // modified sequence to put try after create; rpk 6/5/2015
  Connection := nil;
  Connection := TSFTPConn.Create(Rcon, False, Brkr);
  try
    tmrWndwClose.Enabled := False;
    Connection.Upld2DlDir(FirstIDN + '-Results.txt');
  finally
    ResetWndwTmr;
    Connection.Free;
  end;
end;

{ If Not all available exams selected, prompt user to determine if all
  exams on this request have been scheduled. Causes updates to the 2507
  Request File }

function TExntdCntrctdBaseFormNewRsnd.AllExamsScheduled(): Boolean;
var
  i, SelectedCount, EnabledCount: Integer;
begin
  SelectedCount := 0; EnabledCount := 0;                                        // gbh
  for i := 0 to chkdLstBxExams.Items.Count - 1 do
    if (chkdLstBxExams.ItemEnabled[i]) then
    begin
      Inc(EnabledCount);
      if (chkdLstBxExams.Checked[i]) then Inc(SelectedCount);
    end;

  Result := True;
  _AllExamsChecked := True;
  i := -1;
  repeat
    Inc(i);
    if (chkdLstBxExams.ItemEnabled[i] and (Not chkdLstBxExams.Checked[i])) then
      Result := False;
  until
 // ((Not Result) or
  i = (chkdLstBxExams.Items.Count - 1);
  { All available exams NOT selected, prompt user to determine if all exams
    for the request have been scheduled. }

  if (Not Result) then
  begin
    _AllExamsChecked := False;
    Result := (MessageDlgCAPRI('You have selected ' + inttostr(SelectedCount) +
      ' of ' + inttostr(EnabledCount) + ' enabled exams in this request.' + #13#10 +
      'Does this assignment include all of the examinations for this request?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes);
  end;



// ==============================================================================
end;

{ Update Appropriate Contractor Exam Info Fields in VistA Account for selected exams }

function TExntdCntrctdBaseFormNewRsnd.CheckOutExams(): Boolean;
var
  i, numExms: Integer;
  err, updtRqst: Boolean;
  tmpDTM: TDateTime;
  iens, exmIEN, cntrctrIEN, chkOutDTM: String;
begin
  _SlctdExamList.Clear;
  i := -1;
  iens := '';
  err := False;
  tmpDTM := Now;                                                                { Gets Current System Date/Time }

  updtRqst := AllExamsScheduled;                                                { Determine if All exams have been scheduled }
        // TODO : LMS - next rev.. does this do anything

  cntrctrIEN := fmCmbBxContractor.GetSelectedRecord.IEN;
  LongTimeFormat := 'hhnnss';                                                   { Used by TimeToStr to format result }
  chkOutDTM := DelphiDateToFMInternal(tmpDTM) + '.' + TimeToStr(tmpDTM);
  { At Least One Record had to be selected to get here }
  repeat
    inc(i);
    if chkdLstBxExams.ItemEnabled[i] then
      if chkdLstBxExams.Checked[i] or chkBxCntrctAllExams.Checked then
      begin
        exmIEN := IntToStr(Integer(chkdLstBxExams.Items.Objects[i]));
        iens := iens + '^' + exmIEN;                                            { Store IENS in case need to back out }
        _SlctdExamList.Add(Piece(chkdLstBxExams.Items[i], '['));
        err := Not _2507Info.CheckOutExam(exmIEN, cntrctrIEN, chkOutDTM);
      end;                                                                      { End If Item enabled and is checked or all items checkbox is checked }
  until ((i = (chkdLstBxExams.Items.Count - 1)) or err);
  { Update 2507 Request info if applicable and NO errors updating exams }
  if ((Not err) and updtRqst) then
  begin                                                                         // gbh here
{    if (not _AllExamsChecked) then
      begin
        if (not MessageDlgCAPRI(
        'Hello?' + #13#10, mtConfirmation, [mbYes, mbNo], 0) = mrYes) then exit;
      end;
}
    err := Not _2507Info.UpdtRqstToSchld(fmCmbBx2507Rqsts.GetSelectedRecord.IEN,
      'S', Piece(chkOutDTM, '.'));
    { Reset 2507 Request info if error occurred }
    if err then                                                                 { Status Value to be retrieved from Lister in 2507Info Class }
      _2507Info.UpdtRqstToSchld(fmCmbBx2507Rqsts.GetSelectedRecord.IEN, '', '@', True);
  end;                                                                          { End If Not Error and Update Request Required }
  { Error Occurred - restore modified exams on system to original state }
  if err then
  begin
    _SlctdExamList.Clear;
    numExms := Occurrences(iens, '^');
    { Delete contracted values previously stored in Exam(s)
      Start with item @ Piece 2 as string is preceeded by ^ }
    for i := 2 to numExms + 1 do
      _2507Info.CheckOutExam(Piece(iens, '^', i), '@', '@');
  end;                                                                          { Error Occurred during exam updates }
  Result := Not err;
end;

procedure TExntdCntrctdBaseFormNewRsnd.SetSftpVAMCInfo(FsftpXMLRequest: IXMLREQUESTType);
const
  CPTN: String = 'VAMC making request: ';
var
  i: Integer;
  val: String;
begin
  { Retrieve VAMC Info }
  fmGetsVAMCInfo.Results.Clear;
  { Division: IEN ^ Facility Name ^ Station # }
  val := GetDivisionOfCBOC(IntCCOWBrkrRef.User.Division);                       //  DONE: LMS we use first 3 chars of Station#, not IEN, throughout CCR application now.  // Piece(_CCOWBrkr.User.Division, '^')
                                                     //  Vendors will use Station #. The only place Site# is used directly is in remote authentication. All business references must be changed in the app to point to Station# (used synonymously with Division (not division field of RPCBroker.User but first 3 digits of piece 3 of it) all through CCR)
  if Not SameText(val, '') then
  begin
    fmGetsVAMCInfo.IENS := val;
    fmGetsVAMCInfo.GetData;
  end;                                                                          { End If User has no division }
  { Create String to Return with VAMC Info }
  try
    val := fmGetsVAMCInfo.GetField('.01').FMDBExternal;
  except
    val := 'UNKNOWN';                                                           { In case entry NOT in Institution File #4 }
  end;                                                                          { End Try/Except Block }
  FsftpXMLRequest.MEDICAL_CENTER.NAME := val;
  { Mailing Address Info }
  for i := 1 to 5 do
  begin
    try
      val := fmGetsVAMCInfo.GetField('4.0' + IntToStr(i)).FMDBExternal;
    except
      val := '';                                                                { No Entry found in File #4 }
    end;                                                                        { End Try/Except Block }
    { Populate XML Request / ensure ALL nodes created }
    case i of
      1: FsftpXMLRequest.MEDICAL_CENTER.ADDRESS_1 := val;
      2: FsftpXMLRequest.MEDICAL_CENTER.ADDRESS_2 := val;
      3: FsftpXMLRequest.MEDICAL_CENTER.CITY := val;
      4: FsftpXMLRequest.MEDICAL_CENTER.STATE := val;
      5: FsftpXMLRequest.MEDICAL_CENTER.ZIP := val;
    end;                                                                        { End VAMC Info for Contractor XML Request Message }
  end;                                                                          { End For Loop }
  { VAMC Primary Phone Number Stored in System Registry }
  FsftpXMLRequest.MEDICAL_CENTER.PHONE := GetRgstryVal(VAMCREGKEY, VAMCREGKEYPHNEVAL);
  { VistA Instance # - Vendors will use this value for determining the folder
    where the completed results get placed in the download folder on SFTP server }
    // DONE: LMS - updated. Vendors will use Station #. The only place Site# is used directly is in remote authentication. All business references must be changed in the app to point to Station# (used synonymously with Division all through CCR)
  FsftpXMLRequest.MEDICAL_CENTER.SITENUMBER := GetDivisionOfCBOC(IntCCOWBrkrRef.User.Division); // DONE: LMS Piece(_CCOWBrkr.User.Division, '^', 3);
end;

procedure TExntdCntrctdBaseFormNewRsnd.SetVlerVAMCInfo(FvlerXMLRequest: IXMLCapriExamRequest);
const
  CPTN: String = 'VAMC making request: ';
var
  i: Integer;
  val: String;
begin
  { Retrieve VAMC Info }
  fmGetsVAMCInfo.Results.Clear;
  { Division: IEN ^ Facility Name ^ Station # }
  val := GetDivisionOfCBOC(IntCCOWBrkrRef.User.Division);                       //  DONE: LMS we use first 3 chars of Station#, not IEN, throughout CCR application now.  // Piece(_CCOWBrkr.User.Division, '^')
                                                     //  Vendors will use Station #. The only place Site# is used directly is in remote authentication. All business references must be changed in the app to point to Station# (used synonymously with Division (not division field of RPCBroker.User but first 3 digits of piece 3 of it) all through CCR)
  if Not SameText(val, '') then
  begin
    fmGetsVAMCInfo.IENS := val;
    fmGetsVAMCInfo.GetData;
  end;                                                                          { End If User has no division }
  { Create String to Return with VAMC Info }
  try
    val := fmGetsVAMCInfo.GetField('.01').FMDBExternal;
  except
    val := 'UNKNOWN';                                                           { In case entry NOT in Institution File #4 }
  end;                                                                          { End Try/Except Block }
  FvlerXMLRequest.MedicalCenter.SiteName := val;
  { Mailing Address Info }
  for i := 1 to 5 do
  begin
    try
      val := fmGetsVAMCInfo.GetField('4.0' + IntToStr(i)).FMDBExternal;
    except
      val := '';                                                                { No Entry found in File #4 }
    end;                                                                        { End Try/Except Block }
    { Populate XML Request / ensure ALL nodes created }
    case i of
      1: FvlerXMLRequest.MedicalCenter.Address1 := val;
      2: FvlerXMLRequest.MedicalCenter.Address2 := val;
      3: FvlerXMLRequest.MedicalCenter.City := val;
      4: FvlerXMLRequest.MedicalCenter.State := val;
      5: FvlerXMLRequest.MedicalCenter.ZipCode := val;
    end;                                                                        { End VAMC Info for Contractor XML Request Message }
  end;                                                                          { End For Loop }
  { VAMC Primary Phone Number Stored in System Registry }
  FvlerXMLRequest.MedicalCenter.Phone := GetRgstryVal(VAMCREGKEY, VAMCREGKEYPHNEVAL);
  { VistA Instance # - Vendors will use this value for determining the folder
    where the completed results get placed in the download folder on SFTP server }
    // DONE: LMS - updated. Vendors will use Station #. The only place Site# is used directly is in remote authentication. All business references must be changed in the app to point to Station# (used synonymously with Division all through CCR)
  FvlerXMLRequest.MedicalCenter.SiteNumber.Value := GetDivisionOfCBOC(IntCCOWBrkrRef.User.Division); // DONE: LMS Piece(_CCOWBrkr.User.Division, '^', 3);
  FvlerXMLRequest.MedicalCenter.SiteNumber.AssigningAuthority := CLIENT_ASSIGNING_AUTHORITY_VA;
end;

procedure TExntdCntrctdBaseFormNewRsnd.SetPatientInfoInSftpXML(AXMLRequest: IXMLREQUESTType);
var
  dteOfBrth: String;
begin
  try
    dteOfBrth := FormatDateTime('mm/dd/yyyy', VarToDateTime(_PtntInfo.PatientDOB));
  except
    dteOfBrth := 'Unknown (Error Converting Value)';                            { Not Expected to occur }
  end;                                                                          { End Try/Except Block }
  { XML Request Message - Patient Info }
  AXMLRequest.PATIENT.NAME := _PtntInfo.PatientName;
  AXMLRequest.PATIENT.FIRSTNAME := _PtntInfo.PatientFirstName;
  AXMLRequest.PATIENT.MIDDLENAME := _PtntInfo.PatientMiddleName;
  AXMLRequest.PATIENT.LASTNAME := _PtntInfo.PatientLastName;
  AXMLRequest.PATIENT.SSN := _PtntInfo.GetExternalSSN;
  AXMLRequest.PATIENT.DOB := dteOfBrth;
  AXMLRequest.PATIENT.SEX := _PtntInfo.PatientSEX;
  AXMLRequest.PATIENT.CLAIM_FOLDER_NUM := _PtntInfo.PatientClaimFolderNumber;
  if Not _PtntInfo.HasBadAddress then
  begin
    AXMLRequest.PATIENT.ADDRESS_1 := _PtntInfo.PatientAddress1;
    AXMLRequest.PATIENT.ADDRESS_2 := _PtntInfo.PatientAddress2;
    AXMLRequest.PATIENT.ADDRESS_3 := _PtntInfo.PatientAddress3;
    AXMLRequest.PATIENT.CITY := _PtntInfo.PatientCity;
    AXMLRequest.PATIENT.STATEORPROVINCE := _PtntInfo.PatientStateOrProvince;
    AXMLRequest.PATIENT.ZIP := _PtntInfo.PatientZip;
    AXMLRequest.PATIENT.COUNTRY := _PtntInfo.PatientCountry;
  end                                                                           { End If Patient Address Valid }
  else
  begin
    { Set to NULL so Nodes show up in created XML Request Document }
    AXMLRequest.PATIENT.ADDRESS_1 := '';
    AXMLRequest.PATIENT.ADDRESS_2 := '';
    AXMLRequest.PATIENT.ADDRESS_3 := '';
    AXMLRequest.PATIENT.CITY := '';
    AXMLRequest.PATIENT.STATEORPROVINCE := '';
    AXMLRequest.PATIENT.ZIP := '';
    AXMLRequest.PATIENT.COUNTRY := '';
  end;                                                                          { End If Patient Address marked as Invalid }
  AXMLRequest.PATIENT.PHONE.HOME := _PtntInfo.PatientHomePhone;
  AXMLRequest.PATIENT.PHONE.CELL := _PtntInfo.PatientCellPhone;
end;

procedure TExntdCntrctdBaseFormNewRsnd.SetPatientInfoInVlerXML(AXMLRequest: IXMLCapriExamRequest);
var
  tStr: String;
  tChar: smallint;
begin
  { XML Request Message - Patient Info }
  AXMLRequest.PATIENT.FullName := _PtntInfo.PatientName;
  AXMLRequest.PATIENT.FIRSTNAME := _PtntInfo.PatientFirstName;
  AXMLRequest.PATIENT.MIDDLENAME := _PtntInfo.PatientMiddleName;
  AXMLRequest.PATIENT.LASTNAME := _PtntInfo.PatientLastName;

  tStr := _PtntInfo.PatientSSN;                                                 // GetExternalSSN;  All VLER exchanges will not use any formatting
  AXMLRequest.PATIENT.SSN.Value := tStr;
  tStr := copy(tStr, length(tStr), 1);
  tChar := ord(tStr[1]);
  if (tChar > 47) and (tChar < 58) then                                         // the last char is a digit, so assume regular SSN
    AXMLRequest.PATIENT.SSN.AssigningAuthority := CLIENT_ASSIGNING_AUTHORITY_SSA
  else
    AXMLRequest.PATIENT.SSN.AssigningAuthority := CLIENT_ASSIGNING_AUTHORITY_VA;

  AXMLRequest.PATIENT.ICN.AssigningAuthority := CLIENT_ASSIGNING_AUTHORITY_VA;  // DONE: LMS get correct value LOCALLY ASSIGNED ICN           2,991.04
                                                                                 //        e.g. RPCBrokerDOD.RemoteProcedure := 'DVBAB FIND DFN BY ICN';

  AXMLRequest.PATIENT.ICN.Value := _PtntInfo.PatientICN;

  try
    tStr := FormatDateTime('yyyy-mm-dd', VarToDateTime(_PtntInfo.PatientDOB));
  except
    tStr := '1890-01-01';                                                       { Not Expected to occur }
  end;                                                                          { End Try/Except Block }
  AXMLRequest.PATIENT.DateOfBirth := tStr;

  tStr := _PtntInfo.PatientSEX;
  if tStr = 'M' then tStr := 'Male'
  else if tStr = 'F' then tStr := 'Female';
  //else tStr := 'Unknown';
  AXMLRequest.PATIENT.Gender := tStr;                                           // DONE: LMS check value

  AXMLRequest.PATIENT.ClaimFolderNumber := _PtntInfo.PatientClaimFolderNumber;
  if Not _PtntInfo.HasBadAddress then
  begin
    AXMLRequest.PATIENT.ADDRESS1 := _PtntInfo.PatientAddress1;
    AXMLRequest.PATIENT.ADDRESS2 := _PtntInfo.PatientAddress2;
    AXMLRequest.PATIENT.ADDRESS3 := _PtntInfo.PatientAddress3;
    AXMLRequest.PATIENT.CITY := _PtntInfo.PatientCity;
    AXMLRequest.PATIENT.STATE := _PtntInfo.PatientStateOrProvince;
    AXMLRequest.PATIENT.ZIPCode := _PtntInfo.PatientZip;
    AXMLRequest.PATIENT.COUNTRY := _PtntInfo.PatientCountry;
  end                                                                           { End If Patient Address Valid }
  else
  begin
    { Set to NULL so Nodes show up in created XML Request Document }
    AXMLRequest.PATIENT.ADDRESS1 := '';
    AXMLRequest.PATIENT.ADDRESS2 := '';
    AXMLRequest.PATIENT.ADDRESS3 := '';
    AXMLRequest.PATIENT.CITY := '';
    AXMLRequest.PATIENT.STATE := '';
    AXMLRequest.PATIENT.ZIPCode := '';
    AXMLRequest.PATIENT.COUNTRY := '';
  end;                                                                          { End If Patient Address marked as Invalid }
  AXMLRequest.PATIENT.PHONE.HomePhone := _PtntInfo.PatientHomePhone;
  AXMLRequest.PATIENT.PHONE.MobilePhone := _PtntInfo.PatientCellPhone;
end;

end.

