unit mailmanmessage;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Buttons,
  ComCtrls,
  Diaccess,
  Fmcmpnts,
  Fmcntrls,
  ExtCtrls,
  wdwstate,
  caprisupport,
  Trpcb,
  DiTypLib,
  Tabnotbk,
  mapicontrol,
  OleCtrls;

type
  TFrmMailMessage = class(TForm)
    btnClose: TBitBtn;
    PanelMailMessageHeader: TPanel;
    labelMessageHeader1: TLabel;
    labelMessageHeader2: TLabel;
    LabelIEN: TLabel;
    BitBtnReply: TBitBtn;
    BitBtnForward: TBitBtn;
    BitBtnPrint: TBitBtn;
    BitBtnMakeNew: TBitBtn;
    BitBtnTerminate: TBitBtn;
    BitBtnInfoOnly: TBitBtn;
    FMGetsMailMessage: TFMGets;
    FMGetsNewPerson: TFMGets;
    FMListerResponses: TFMLister;
    FMListerRecipients: TFMLister;
    FMGetsRecipientInfo: TFMGets;
    FMGetsMailBasketMessage: TFMGets;
    FMGetsMailBaskets: TFMGets;
    FMGetsMailBox: TFMGets;
    FMListerMailBoxMessages: TFMLister;
    BitBtnDelete: TBitBtn;
    Label1: TLabel;
    TabbedNotebook1: TTabbedNotebook;
    ScrollBox1: TScrollBox;
    FMListBoxResponses: TFMListBox;
    FMListBoxRecipients: TFMListBox;
    FMListBoxMailboxMessages: TFMListBox;
    FMEditNewMessagesInBasket: TFMEdit;
    FMEditNewMessagesForUser: TFMEdit;
    FMEditLastResponseRead: TFMEdit;
    FMEditLastReadDateTime: TFMEdit;
    FMEditTerminationDate: TFMEdit;
    FMEditFirstReadDateTime: TFMEdit;
    FMEditInReplyToRemoteMessageID: TFMEdit;
    FMEditIncomingMessageID: TFMEdit;
    FMEditInformationOnly: TFMEdit;
    FMEditConfidential: TFMEdit;
    FMEditClosedMessage: TFMEdit;
    FMEditLocalCreateDate: TFMEdit;
    FMEditOriginalMessage: TFMEdit;
    FMEditResponseDateTime: TFMEdit;
    FMEditResponseName: TFMEdit;
    FMEditConfirmationRequested: TFMEdit;
    FMEditScrambleHint: TFMEdit;
    FMEditScrambleKey: TFMEdit;
    FMEditDeliveryBasket: TFMEdit;
    FMEditMailBasketNewFlag: TFMEdit;
    FMEditMailBasketMessage: TFMEdit;
    FMEditMailBasketMessageIndex: TFMEdit;
    FMEditMailBasketMessageLastReadDateTime: TFMEdit;
    FMEditMailBasketMessageAutomaticDeleteDate: TFMEdit;
    FMEditMailBasketMessageNetworkPriorityTransmission: TFMEdit;
    FMEditMailBasketMessageDeleteDateSetByMailman: TFMEdit;
    FMMemoMailMessage: TFMMemo;
    FMEditName: TFMEdit;
    LabelRow: TLabel;
    MemoRecipients: TMemo;
    FMGetsMailMessage2: TFMGets;
    FMEditMailBasketMessageMessageType: TFMEdit;
    FMEditResponseFromName: TFMEdit;
    FMEditResponseFromNameSurrogate: TFMEdit;
    FMEditResponseNameSurrogate: TFMEdit;
    BitBtnReplyOriginator: TBitBtn;
    FMListerMailManSiteParameters: TFMLister;
    FMListBoxMailManSiteParameters: TFMListBox;
    Label2: TLabel;
    xMapiControl: TMapiControl;
    MemoMessageText: TMemo;
    Panel1: TPanel;
    LabelMessageResponses: TLabel;
    LabelMessageResponsesRead: TLabel;
    LabelLastRead: TLabel;
    LabelMessageTerminated: TLabel;
    procedure btnCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FMEditResponseDateTimeChange(Sender: TObject);
    procedure BitBtnTerminateClick(Sender: TObject);
    procedure BitBtnDeleteClick(Sender: TObject);
    procedure BitBtnMakeNewClick(Sender: TObject);
    procedure BitBtnReplyOriginatorClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMailMessage: TFrmMailMessage;
  fmDateNow: string;

implementation

uses main,
  mailman;

{$R *.DFM}

procedure TFrmMailMessage.btnCloseClick(Sender: TObject);
begin
  //Update Last Response Read and Last Read Date/Time
  if FMListBoxResponses.Items.Count > 0 then
    if FMListBoxResponses.Items.Count <> FMListBoxResponses.Items.Count then begin
      FMEditLastResponseRead.Text := IntToStr(FMListBoxResponses.Items.Count);
      FMEditFilePrepare(FMEditLastResponseRead);
      FMFile;
    end;
  if FMEditMailBasketNewFlag.Text = 'NEW' then begin
    // Clear new flag
    FMEditMailBasketNewFlag.Text := '@';
    FMEditFilePrepare(FMEditMailBasketNewFlag);
    frmMain.FMFiler1.AddFDA('3.701', FMEditNewMessagesInBasket.IENS, '2', IntToStr(StrToInt(FMEditNewMessagesInBasket.Text) - 1));
    frmMain.FMFiler1.AddFDA('3.7', FMEditNewMessagesForUser.IENS, '1.1', IntToStr(StrToInt(FMEditNewMessagesForUser.Text) - 1));
    FMFile;
  end;
  FMEditMailBasketMessageLastReadDateTime.Text := 'NOW';
  FMEditFilePrepare(FMEditMailBasketMessageLastReadDateTime);
  FMFile;
  //FrmMailMessage.Release;
  //modalresult:=mrOK;
  modalResult := mrOK;
end;

procedure TFrmMailMessage.FormCreate(Sender: TObject);
begin
  FMGetsMailMessage.RPCBroker := frmMain.RPCBroker1;
  FMGetsNewPerson.RPCBroker := frmMain.RPCBroker1;
end;

procedure TFrmMailMessage.FMEditResponseDateTimeChange(Sender: TObject);
var
  x: integer;
  a: string;
begin
  a := FMEditResponseDateTime.Text;
  if a = '' then
    exit;
  for x := 1 to length(a) do
    if a[x] = '@' then
      a[x] := ' ';
  FMEditResponseDateTime.Text := a;
end;

procedure TFrmMailMessage.BitBtnTerminateClick(Sender: TObject);
var
  wasteien: string;
  tempien: string;
begin
  if Application.MessageBox('Are you sure you want to terminate this message?', 'Mailman Action', 4) = 6 then begin

    FMEditTerminationDate.Text := 'NOW';
    FMEditFilePrepare(FMEditTerminationDate);
    // Strip Date
    FMEditTerminationDate.Text := Piece(FMEditTerminationDate.Text, '@', 1);
    FMEditFilePrepare(FMEditTerminationDate);
    // Now file
    FMFile;
    wasteien := '.5';
    //frmMain.FMValidator1.Setup('3.702','+1,'+wasteien+','+AuthorIEN+',','.01','`'+labelIEN.Caption);
    //If not frmmain.FMValidator1.Validate then frmmain.FMValidator1.DisplayErrors
    //else application.terminate;
    tempIEN := '+' + labelIEN.Caption + ',' + wasteien + ',' + AuthorIEN + ',';
    frmMain.FMFiler1.AddFDA('3.702', tempien, '.01', labelIEN.Caption);
    frmMain.FMFiler1.AddFDA('3.702', tempien, '4', Piece(FMGetsMailBasketMessage.GetField('4').FMDBInternal, '.', 1)); // Just date, not time
    //frmMain.FMFiler1.AddFDA('3.702',tempien,'5',FMGetsMailBasketMessage.GetField('5').FMDBInternal);
    //frmMain.FMFiler1.AddFDA('3.702',tempien,'6',FMGetsMailBasketMessage.GetField('6').FMDBInternal);
    //frmMain.FMFiler1.AddFDA('3.702',tempien,'7',FMGetsMailBasketMessage.GetField('7').FMDBInternal);
    FMFile;
    tempIEN := Piece(frmMain.FMFiler1.NewIENs[0], '^', 2);
    // Reset New message Count if message is new
    if FMEditMailBasketNewFlag.Text = 'NEW' then begin
      FMEditMailBasketNewFlag.Text := '@';
      FMEditFilePrepare(FMEditMailBasketNewFlag);
      frmMain.FMFiler1.AddFDA('3.701', FMEditNewMessagesInBasket.IENS, '2', IntToStr(StrToInt(FMEditNewMessagesInBasket.Text) - 1));
      frmMain.FMFiler1.AddFDA('3.7', FMEditNewMessagesForUser.IENS, '1.1', IntToStr(StrToInt(FMEditNewMessagesForUser.Text) - 1));
      FMFile;
    end;
    DeleteRecord(frmMain.RPCBroker1, '3.702', FMGetsMailBasketMessage.IENS);

    //frmMailMan.FMListBoxMailBasketsClick(Application);
    //FrmMailMessage.Release;

    // Need to fix the global because Delphi creates a default global
    // It needs to be set a specific way

    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBA FIX MOVED MESSAGE';
    frmMain.RPCBroker1.Param[0].Value := tempIEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBroker1.Param[1].Value := '.5'; // .5= Wastebasket
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBrokerCall;
    frmMain.RPCBroker1.Call;
    (*
          except
        On EBrokerError do begin;  ANURemoteProcedureCallInProgress:=False;
          frmMain.GIFImageVistaYellow.Animate:=False;
          frmMain.StatusBarLoadPt.Caption:='RPC DVBA FIX MOVED MESSAGE could not be accessed!'; frmMain.StatusBarLoadPt.Repaint; Application.Processmessages;
          ShowMessageCAPRI('DVBAB DVBA FIX MOVED MESSAGE could not be accessed!');
        end; end;
      *)
    modalresult := mrCancel;
  end;
end;

procedure TFrmMailMessage.BitBtnDeleteClick(Sender: TObject);
var
  wasteien: string;
  tempien: string;
begin
  if Application.MessageBox('Are you sure you want to delete this message?', 'Mailman Action', 4) = 6 then begin

    wasteien := '.5';
    //frmMain.FMValidator1.Setup('3.702','+1,'+wasteien+','+AuthorIEN+',','.01','`'+labelIEN.Caption);
    //If not frmmain.FMValidator1.Validate then frmmain.FMValidator1.DisplayErrors
    //else application.terminate;
    tempIEN := '+' + labelIEN.Caption + ',' + wasteien + ',' + AuthorIEN + ',';
    frmMain.FMFiler1.AddFDA('3.702', tempien, '.01', labelIEN.Caption);
    frmMain.FMFiler1.AddFDA('3.702', tempien, '4', Piece(FMGetsMailBasketMessage.GetField('4').FMDBInternal, '.', 1)); // Just date, not time
    //frmMain.FMFiler1.AddFDA('3.702',tempien,'5',FMGetsMailBasketMessage.GetField('5').FMDBInternal);
    //frmMain.FMFiler1.AddFDA('3.702',tempien,'6',FMGetsMailBasketMessage.GetField('6').FMDBInternal);
    //frmMain.FMFiler1.AddFDA('3.702',tempien,'7',FMGetsMailBasketMessage.GetField('7').FMDBInternal);
    FMFile;

    // Update new message controls in case a message has arrived recently so that he count
    // won't be wrong
    frmMailMessage.FMGetsMailBaskets.IENS := frmMailMan.FMListBoxMailBaskets.GetSelectedRecord.IEN + frmMailMan.FMListerMailBaskets.IENS;
    frmMailMessage.FMEditNewMessagesInBasket.IENS := frmMailMessage.FMGetsMailBaskets.IENS;
    frmMailMessage.FMGetsMailBaskets.GetAndFill;
    frmMailMessage.FMGetsMailBox.IENS := Piece(frmMailMan.FMListerMailBaskets.IENS, ',', 2);
    frmMailMessage.FMEditNewMessagesForUser.IENS := frmMailMessage.FMGetsMailBox.IENS;
    frmMailMessage.FMGetsMailBox.GetAndFill;

    tempIEN := Piece(frmMain.FMFiler1.NewIENs[0], '^', 2);
    // Reset New message Count if message is new
    if FMEditMailBasketNewFlag.Text = 'NEW' then begin
      FMEditMailBasketNewFlag.Text := '@';
      FMEditFilePrepare(FMEditMailBasketNewFlag);
      frmMain.FMFiler1.AddFDA('3.701', FMEditNewMessagesInBasket.IENS, '2', IntToStr(StrToInt(FMEditNewMessagesInBasket.Text) - 1));
      frmMain.FMFiler1.AddFDA('3.7', FMEditNewMessagesForUser.IENS, '1.1', IntToStr(StrToInt(FMEditNewMessagesForUser.Text) - 1));
      FMFile;
    end;
    DeleteRecord(frmMain.RPCBroker1, '3.702', FMGetsMailBasketMessage.IENS);

    //frmMailMan.FMListBoxMailBasketsClick(Application);
    //FrmMailMessage.Release;

    // Need to fix the global because Delphi creates a default global
    // It needs to be set a specific way

    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB MAIL FIX MOVED MESSAGE';
    frmMain.RPCBroker1.Param[0].Value := tempIEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBroker1.Param[1].Value := '.5';
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBrokerCall;
    frmMain.RPCBroker1.Call;
    modalresult := mrCancel;
  end;
end;

procedure TFrmMailMessage.BitBtnMakeNewClick(Sender: TObject);
begin
  //Update Last Response Read and Last Read Date/Time
  if FMListBoxResponses.Items.Count > 0 then
    if FMListBoxResponses.Items.Count <> FMListBoxResponses.Items.Count then begin
      FMEditLastResponseRead.Text := IntToStr(FMListBoxResponses.Items.Count);
      FMEditFilePrepare(FMEditLastResponseRead);
      FMFile;
    end;

  // Update new message controls in case a message has arrived recently so that he count
  // won't be wrong
  frmMailMessage.FMGetsMailBaskets.IENS := frmMailMan.FMListBoxMailBaskets.GetSelectedRecord.IEN + frmMailMan.FMListerMailBaskets.IENS;
  frmMailMessage.FMEditNewMessagesInBasket.IENS := frmMailMessage.FMGetsMailBaskets.IENS;
  frmMailMessage.FMGetsMailBaskets.GetAndFill;
  frmMailMessage.FMGetsMailBox.IENS := Piece(frmMailMan.FMListerMailBaskets.IENS, ',', 2);
  frmMailMessage.FMEditNewMessagesForUser.IENS := frmMailMessage.FMGetsMailBox.IENS;
  frmMailMessage.FMGetsMailBox.GetAndFill;

  if FMEditMailBasketNewFlag.Text <> 'NEW' then begin
    // Clear new flag
    FMEditMailBasketNewFlag.Text := 'NEW';
    FMEditFilePrepare(FMEditMailBasketNewFlag);
    try
    frmMain.FMFiler1.AddFDA('3.701', FMEditNewMessagesInBasket.IENS, '2', IntToStr(StrToInt(FMEditNewMessagesInBasket.Text) + 1))except
      frmMain.FMFiler1.AddFDA('3.701', FMEditNewMessagesInBasket.IENS, '2', '1')
    end;
    try
    frmMain.FMFiler1.AddFDA('3.7', FMEditNewMessagesForUser.IENS, '1.1', IntToStr(StrToInt(FMEditNewMessagesForUser.Text) + 1))except
      frmMain.FMFiler1.AddFDA('3.7', FMEditNewMessagesForUser.IENS, '1.1', '1');
    end;
    FMFile;
  end;
  FMEditMailBasketMessageLastReadDateTime.Text := 'NOW';
  FMEditFilePrepare(FMEditMailBasketMessageLastReadDateTime);
  FMFile;
  //FrmMailMessage.Release;
  frmMailMan.buttonNew.enabled := True;
  modalResult := mrOK;
end;

procedure TFrmMailMessage.BitBtnReplyOriginatorClick(Sender: TObject);
var
  vistaemailaddress: string;
  x: integer;
  mailsender2: string;
begin
  FMListBoxMailManSiteParameters.GetList;
  if FMListBoxMailManSiteParameters.Items.Count <> 1 then begin
    ShowMessageCAPRI('Unable to detect e-mail address.');
  end;
  vistaemailaddress := FMListBoxMailManSiteParameters.Items[0];

  xMapiControl.Reset;
  xMapiControl.ShowDialog := True;
  if Copy(labelMessageHeader2.caption, 1, 4) = 'RE: ' then
    xMapiControl.Subject := labelMessageHeader2.caption
  else
    xMapiControl.Subject := 'RE: ' + labelMessageHeader2.caption;
  mailsender2 := mailsender;
  // Check for space in front
  if mailsender2[1] = ' ' then
    mailsender2 := copy(mailsender, 2, length(mailsender) - 1);
  if mailsender <> '' then begin
    for x := 1 to length(mailsender2) do
      if mailsender2[x] = ',' then
        mailsender2[x] := '.';
    for x := 1 to length(mailsender2) do
      if mailsender2[x] = ' ' then
        mailsender2[x] := '_';
  end;
  if Pos('@', mailsender2) = 0 then
    xMapiControl.Recipients.Add('<' + mailsender2 + '@' + vistaemailaddress + '>')
  else
    xMapiControl.Recipients.Add('<' + mailsender2 + '>');
  xMapiControl.Body := '';
  xMapiControl.Sendmail;
end;

procedure TFrmMailMessage.FormActivate(Sender: TObject);
begin
  if MakingNew = True then begin
    btnCloseClick(Application);
  end;
end;

end.
