unit pncsmanagetemplates;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ORCtrls,
  ComCtrls,
  DialogsCAPRI,
  Gauges,
  PNCSCodeRun,
  ExtCtrls,
  Diaccess,
  Fmcmpnts,
  Fmcntrls;

type
  TfrmManageTemplates = class(TForm)
    Label1: TLabel;
    ORListBoxCurrentTemplates: TORListBox;
    Label2: TLabel;
    ORListBoxAddTemplates: TORListBox;
    ButtonDeleteTemplates: TButton;
    Button1: TButton;
    Label3: TLabel;
    Gauge1: TGauge;
    Timer1: TTimer;
    Panel1: TPanel;
    Gauge2: TGauge;
    FMListBox1: TFMListBox;
    FMLister1: TFMLister;
    procedure ButtonDeleteTemplatesClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ORListBoxCurrentTemplatesClick(Sender: TObject);
    procedure ORListBoxAddTemplatesClick(Sender: TObject);
    procedure UpdateGauge;
    procedure FormActivate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure SaveBeforeMerge;
  public
    { Public declarations }
    StartCount: Integer;
  end;

var
  frmManageTemplates: TfrmManageTemplates;
  ScriptStyle: string;

implementation

uses
  browsetemplates,
  CapriSupport,
  main,
  PNCSMain;

{$R *.DFM}


procedure TfrmManageTemplates.ButtonDeleteTemplatesClick(Sender: TObject);
var
  DeleteCount      : integer;
  tempstring : string;
  tempstring2: string;
  x          : integer;
begin
  if Gauge1.ForeColor = clRed then begin
    ShowMessageCAPRI('You''ve selected too many forms.  Either remove some of the new ones or choose existing ones for deletion.');
    exit;
  end;

  tempstring := '';
  tempstring2 := '';
  DeleteCount := 0;
  for x := 0 to ORListBoxCurrentTemplates.Items.Count - 1 do
    if ORListBoxCurrentTemplates.Selected[x] = true then begin
      inc(DeleteCount);
      tempstring := tempstring + char(13) + char(10) + '     ' + frmMain.Piece(ORListBoxCurrentTemplates.Items[x], '^', 2);
    end;
  for x := 0 to ORListBoxAddTemplates.Items.Count - 1 do
    if ORListBoxAddTemplates.Selected[x] = true then begin
      tempstring2 := tempstring2 + char(13) + char(10) + '     ' + frmMain.Piece(ORListBoxAddTemplates.Items[x], '^', 2);
    end;

  if (tempstring = '') and (tempstring2 = '') then begin
    ShowMessageCAPRI('No templates have been selected.');
    Exit;
  end;

  if DeleteCount = ORListBoxCurrentTemplates.Items.Count then
  begin
    ShowMessageCAPRI('Request denied.  Each form must contain at least 1 of the original templates.');
    Exit;
  end;

  if DeleteCount > 0 then
  begin
    if MessageDlgCAPRI('WARNING: You are about to remove and permanently lose data associated with the following template(s):' + tempstring +
      char(13) + char(10) + char(13) + char(10) + 'Are you sure?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      SaveBeforeMerge;
      //Remove deleted templates from current list
      for x := ORListBoxCurrentTemplates.Items.Count - 1 downto 0 do
        if ORListBoxCurrentTemplates.Selected[x] = True then
          ORListBoxCurrentTemplates.Items.Delete(x);
      mergedFormMode := true;
      modalresult := mrOK;
    end;
  end
  else
  begin
    SaveBeforeMerge;
    MergedFormMode := True;
    modalresult := mrOK;
  end;
end;  { ButtonDeleteTemplatesClick }

procedure TfrmManageTemplates.Button1Click(Sender: TObject);
begin
  modalResult := mrCancel;
end;

procedure TfrmManageTemplates.ORListBoxCurrentTemplatesClick(
  Sender: TObject);
begin
  UpdateGauge;
end;

procedure TfrmManageTemplates.ORListBoxAddTemplatesClick(Sender: TObject);
begin
  UpdateGauge;
end;

procedure TfrmManageTemplates.UpdateGauge;
var
  resourceCount: integer;
  x, y: integer;
begin
  resourceCount := 0;
  Gauge1.MaxValue := frmBrowseTemplates.Gauge1.MaxValue;
  // First do current forms if not highlighted
  for x := 0 to ORListBoxCurrentTemplates.Items.Count - 1 do
    for y := 0 to frmBrowseTemplates.FMListBoxAllTemplates.Items.Count - 1 do
      // Compare IENS
      if ORListBoxCurrentTemplates.Selected[x] = False then // Selected ones here will be deleted, so don't count them
        if frmMain.Piece(frmBrowseTemplates.FMListBoxAllTemplates.Items[y], '^', 6) = frmMain.Piece(ORListBoxCurrentTemplates.Items[x], '^', 1) then begin
          // Add object count from form list on form picker
          // Use the "alltemplates" item because it has all forms, even outdated ones or ones
          // the user may not be able to select any more
          resourcecount := resourcecount + strtoint(frmMain.Piece(frmBrowseTemplates.FMListBoxAllTemplates.Items[y], '^', 5));
          break; // found a match, so go on to next item in the x loop
        end;

  // Next do new forms to be added
  for x := 0 to ORListBoxAddTemplates.Items.Count - 1 do
    if ORListBoxAddTemplates.Selected[x] = True then
      resourcecount := resourcecount + strtoint(frmMain.Piece(ORListBoxAddTemplates.Items[x], '^', 3));

  Gauge1.Progress := ResourceCount;
  if ResourceCount > Gauge1.MaxValue then begin
    Gauge1.ForeColor := clRed;
  end
  else begin
    Gauge1.ForeColor := clBlack;
  end;

end;

procedure TfrmManageTemplates.FormActivate(Sender: TObject);
var
  x, y: integer;
begin
  UpdateGauge;
  if mergeform <> '' then
  begin
    if MergeForm[1] = '^' then
      MergeForm := Copy(mergeform, 2, length(mergeform));
    for x := 0 to ORListBoxAddTemplates.Items.Count - 1 do
      if Piece(mergeform, '~', 1) = Piece(ORListBoxAddTemplates.Items[x], '^', 1) then
      begin
        ORListBoxAddTemplates.Selected[x] := true;
        Timer1.Enabled := True;
      end;
  end;

  ORListBoxCurrentTemplates.Enabled := False;
  ORListBoxAddTemplates.Enabled := False;
  Panel1.Visible := True;
  Panel1.BringToFront;
  ButtonDeleteTemplates.Enabled := False;
  Button1.Enabled := False;
  Gauge2.MaxValue := ORListBoxAddTemplates.Items.Count - 1;

  // Remove forms not compatible with current script
  if ORListBoxAddTemplates.Items.Count > 0 then
    for x := ORListBoxAddTemplates.Items.Count - 1 downto 0 do begin
      Gauge2.Progress := ORListBoxAddTemplates.Items.Count - 1 - x;

      if FMListBox1.Items.Count > 0 then
        for y := 0 to FMListbox1.Items.Count - 1 do begin
          FMListbox1.ItemIndex := y;
          if Piece(ORListBoxAddTemplates.Items[x], '^', 2) = FMListBox1.GetSelectedRecord.IEN then
            if Piece(FMListBox1.Items[y], '^', 2) <> ScriptStyle then begin
              ORListBoxAddTemplates.Items.Delete(x);
              break;
            end;
        end;
    end;

  ORListBoxCurrentTemplates.Enabled := True;
  ORListBoxAddTemplates.Enabled := True;
  Panel1.Visible := False;
  ButtonDeleteTemplates.Enabled := True;
  Button1.Enabled := True;
  If StartCount=-1 Then
    StartCount:= ORListBoxCurrentTemplates.Items.Count;
end;

procedure TfrmManageTemplates.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  mergeform := '';
  ButtonDeleteTemplatesClick(Application);
end;

procedure TfrmManageTemplates.FormCreate(Sender: TObject);
begin
  ScriptStyle := PNCSForm.zzzzEditScriptStyle.Text;
  FMLister1.GetList(FMListBox1.Items);
  StartCount:=-1;
end;

procedure TfrmManageTemplates.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  StartCount:=-1;
end;

procedure TfrmManageTemplates.SaveBeforeMerge;
var
  SaveNameWas: string;
begin
  if StartCount>0 Then
  begin
    SaveNameWas := PNCSForm.SaveName;
    PNCSForm.SaveName := ' Managed Templates - Save Prior to Merge';
    PNCSForm.ManualSave('buttondeletetemplatesclick');
    PNCSForm.SaveName := SaveNameWas;
  end;
end;

end.

