unit pncsrunreport;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  checklst,
  comctrls,
  CPWMRadioGroup,
  ORCtrls;

procedure PNCSReportRun(MemoCode: TRichEdit; MemoReport: TRichEdit; XBaseForm: TWinControl; MemoErrors: TMemo; tempMemoryStream: tStream);
procedure AddToReport(LineNew: AnsiString; MemoReport: TRichEdit);
function CheckIfValidObjectorCommand(xNewWord: string; xBaseForm: TWinControl; MemoErrors: TMemo): Boolean;
function CheckIfValidObjectOutput(xNewWord: string; xBaseForm: TWinControl; MemoErrors: TMemo): Boolean;
procedure PNCSReportRunBlankTemplate(MemoCode: TRichEdit; MemoReport: TRichEdit; XBaseForm: TWinControl; MemoErrors: TMemo; tempMemoryStream: tStream);

var
  CodeString: string;
  ErrorCount: Integer;
  WhichLine: Integer;
  NewWord: AnsiString;
  LineNew: AnsiString;
  Indent: Integer;
  CapsOn: Boolean;
  OutputOn: Boolean;
  tempControl: TControl;
  tempTLabel: TLabel;
  tempTPanel: TPanel;
  tempTGroupBox: TGroupBox;
  tempTScrollBox: TScrollBox;
  tempTRadioGroup: TRadioGroup;
  tempTCPWMRadioGroup: TCPWMRadioGroup;
  tempTEdit: TEdit;
  tempTTrackbar: TTrackBar;
  tempTListBox: TListBox;
  tempTORListBox: TORListBox;
  tempTCheckListBox: TCheckListBox;
  tempTMemoBox: TMemo;
  tempTMemo: TMemo;
  tempTCheckBox: TCheckBox;
  tempTRadioButton: TRadioButton;
  tempTButton: TButton;
  tempTComboBox: TComboBox;
  ProblemListString: string;
  blanktemplate: boolean;
  OutputStringList: TStringList;

implementation

procedure PNCSReportRunBlankTemplate(MemoCode: TRichEdit; MemoReport: TRichEdit; XBaseForm: TWinControl; MemoErrors: TMemo; tempMemoryStream: tStream);
begin
  blanktemplate := true;
  try
    PNCSReportRun(MemoCode, MemoReport, XBaseForm, MemoErrors, tempMemoryStream);
  finally
    blanktemplate := false;
  end;
end;

procedure AddToReport(LineNew: AnsiString; MemoReport: TRichEdit);
var
  xSpace: string;
  xx, yy: integer;
  tempLine: AnsiString;
  tempAddLine: string;
  CurrentLine: Integer;
  DontAddFlag: Boolean;
begin
  if OutputOn = False then
    exit; // Don't do if output not on
  xSpace := '';
  if Indent > 0 then
    for xx := 1 to Indent do
      xSpace := xSpace + ' ';
  CurrentLine := MemoReport.Lines.Count;
  if LineNew = '' then begin
    MemoReport.Lines.Add('');
    exit;
  end;
  // Remove linefeeds
  if Pos(char(10), LineNew) > 0 then
    repeat begin
        LineNew := Copy(LineNew, 1, Pos(Char(10), LineNew) - 1) + Copy(LineNew, Pos(Char(10), LineNew) + 1, Length(LineNew));
    end until Pos(char(10), LineNew) = 0;
  //
  repeat begin
      if Pos(Char(13), LineNew) > 0 then begin
        TempLine := Copy(LineNew, 1, Pos(Char(13), LineNew) - 1); // Gets rid of carriage return
        if ((Length(LineNew) = 1) and (LineNew[1] = Char(13))) then
          LineNew := ''
        else
          LineNew := Copy(LineNew, Pos(Char(13), LineNew) + 1, Length(LineNew) - 1);
      end
      else begin
        TempLine := LineNew;
        LineNew := '';
      end;
      DontAddFlag := False;
      if Length(TempLine) > 77 - Indent + 1 then // Width of line is 77 characters)
        repeat begin
            TempAddLine := Copy(TempLine, 1, 77 - Indent);
            TempLine := Copy(TempLine, 77 - Indent + 1, Length(TempLine));

            // Handle text wrapping, if last character is not a space
            // Don't do text wrapping if there are no spaces
            xx := length(TempAddLine);
            yy := -1;
            if TempAddLine[Length(TempAddLine)] <> ' ' then
              if Pos(' ', tempAddLine) > 0 then
                repeat
                  if TempAddLine[xx] = ' ' then
                    yy := xx;
                  dec(xx);
                until yy > 0;
            if yy = 0 then begin
              TempAddLine := '';
              TempLine := Copy(TempAddLine, yy + 2, length(TempAddLine)) + TempLine;
            end
            else
              if yy > -1 then begin
                // Add back in the wrap stuff to TempLine
                TempLine := Copy(TempAddLine, yy + 1, length(TempAddLine)) + TempLine;
                TempAddLine := Copy(TempAddLine, 1, yy - 1);
              end;
            // End of wrapping portion

            MemoReport.Lines.Add(TempAddLine);
            // Remove leading space, if there is one
            // This is needed if the user puts double spaces at the end of a
            // sentence.
            if Length(TempLine) > 1 then
              if TempLine[1] = ' ' then
                TempLine := Copy(TempLine, 2, Length(TempLine));
        end until Length(TempLine) <= 77 - Indent;
      if DontAddFlag = False then
        MemoReport.Lines.Add(TempLine);
  end until LineNew = '';
  repeat
    MemoReport.Lines[CurrentLine] := xSpace + MemoReport.Lines[CurrentLine];
    CurrentLine := CurrentLine + 1;
  until CurrentLine >= MemoReport.Lines.Count;
end;

function CheckIfValidObjectorCommand(xNewWord: string; XBaseForm: TWinControl; MemoErrors: TMemo): Boolean;
var
  zz: integer;
  tempComponent: tComponent;
begin
  result := False;
  xNewWord := Copy(xNewWord, 3, Length(xNewWord) - 4);
  NewWord := char(1);
  //ShowMessageCAPRI(inttostr(xbaseform.componentcount));
//  If xBaseForm.ComponentCount-1>0 then
//    For xx:=0 to xBaseForm.ComponentCount-1 do begin;

  tempComponent := xBaseform.FindComponent(xNewWord);
  if tempComponent <> nil then begin
    //ShowMessageCAPRI(inttostr(xx)+':'+tempComponent.Name+' - '+xNewWord);
    if UpperCase(tempComponent.Name) = Uppercase(xNewWord) then begin
      result := true;
      NewWord := '';
      if (Uppercase(tempComponent.ClassName) = 'TLABEL') then begin
        tempTLabel := tempComponent as TLabel;
        if tempTLabel.visible = True then
          NewWord := tempTLabel.Caption;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TPANEL') then begin
        tempTPanel := tempComponent as TPanel;
        if tempTPanel.visible = true then
          NewWord := tempTPanel.Caption;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TGROUPBOX') then begin
        tempTGroupBox := tempComponent as TGroupBox;
        if tempTGroupbox.visible = true then
          NewWord := tempTGroupBox.caption;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TSCROLLBOX') then begin
        tempTScrollBox := tempComponent as TScrollBox;
        if TempTScrollBox.visible = True then
          NewWord := '<INVALID OBJECT: SCROLLBOX>';
      end;
      if (Uppercase(tempComponent.ClassName) = 'TBUTTON') then begin
        tempTButton := tempComponent as TButton;
        if tempTButton.visible = True then
          NewWord := tempTButton.Caption;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TLISTBOX') then begin
        tempTListBox := tempComponent as TListBox;
        if TempTListBox.Multiselect = False then begin
          if TempTListBox.visible = True then
            if TempTListBox.ItemIndex > -1 then
              NewWord := TempTListBox.Items[TempTListbox.ItemIndex];
        end
        else begin
          newword := '';
          if TempTListBox.visible = True then
            if TempTListBox.Items.Count > 0 then
              for zz := 0 to TempTListBox.Items.Count - 1 do
                if TempTListBox.Selected[zz] = True then
                  NewWord := NewWord + TempTListBox.Items[zz] + ', ';
          if NewWord <> '' then
            NewWord := Copy(NewWord, 1, Length(NewWord) - 2);
        end;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TORLISTBOX') then begin
        tempTORListBox := tempComponent as TORListBox;
        if TempTORListBox.Multiselect = False then begin
          if TempTORListBox.visible = True then
            if TempTORListBox.ItemIndex > -1 then
              NewWord := TempTORListBox.Items[TempTORListBox.ItemIndex];
        end
        else begin
          newword := '';
          if TempTORListBox.visible = True then
            if TempTORListBox.Items.Count > 0 then
              for zz := 0 to TempTORListBox.Items.Count - 1 do
                if TempTORListBox.Selected[zz] = True then
                  NewWord := NewWord + TempTORListBox.Items[zz] + ', ';
          if NewWord <> '' then
            NewWord := Copy(NewWord, 1, Length(NewWord) - 2);
        end;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TRADIOGROUP') then begin
        tempTRadioGroup := tempComponent as TRadioGroup;
        if TempTRadioGroup.visible = True then
          if tempTRadioGroup.ItemIndex > -1 then
            NewWord := tempTRadioGroup.Items[tempTRadioGroup.ItemIndex];
      end;
      if (Uppercase(tempComponent.ClassName) = 'TCPWMRADIOGROUP') then begin
        tempTCPWMRadioGroup := tempComponent as TCPWMRadioGroup;
        if TempTCPWMRadioGroup.visible = True then
          if tempTCPWMRadioGroup.ItemIndex > -1 then
            NewWord := tempTCPWMRadioGroup.Items[tempTCPWMRadioGroup.ItemIndex];
      end;
      if (Uppercase(tempComponent.ClassName) = 'TCOMBOBOX') then begin
        tempTComboBox := tempComponent as TComboBox;
        //tempTComboBox.ItemIndex:=-1;
        if tempTComboBox.visible = True then
          if tempTComboBox.Text <> '' then
            NewWord := tempTComboBox.Text;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TEDIT') then begin
        tempTEdit := tempComponent as Tedit;
        if TempTEdit.visible = True then
          NewWord := tempTEdit.Text;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TMEMO') then begin
        tempTMemoBox := tempComponent as TMemo;
        newword := '';
        if TempTMemoBox.visible = True then
          if length(tempTMemoBox.Text) > 0 then
            NewWord := NewWord + tempTMemoBox.Text
              //If Length(NewWord)>0 then NewWord:=Copy(NewWord,1,Length(NewWord)-1); // Strip last carriage return
      end;
      if (Uppercase(tempComponent.ClassName) = 'TCHECKBOX') then begin
        tempTCHECKBOX := tempComponent as TCHECKBOX;
        if tempTCheckbox.visible = True then
          if tempTCheckBox.Checked = True then
            NewWord := tempTCheckbox.Caption;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TRADIOBUTTON') then begin
        tempTRADIOBUTTON := tempComponent as TRADIOBUTTON;
        if tempTRadioButton.visible = True then
          if tempTRadioButton.Checked = True then
            NewWord := tempTRadioButton.Caption;
      end;
    end;
  end;
  if Uppercase(xNewWord) = 'PROBLEMLIST' then begin
    NewWord := ProblemListString;
    result := true;
  end;

  if blanktemplate = true then begin
    result := true;
    newword := '';
  end;

  //If NewWord='' then NewWord:='[NO RESPONSE]';
  if NewWord = '' then
    NewWord := '';
  if Uppercase(xNewWord) = 'INDENT2' then begin
    newword := char(1);
    indent := 2;
    result := true;
  end;
  if Uppercase(xNewWord) = 'INDENT4' then begin
    newword := char(1);
    indent := 4;
    result := true;
  end;
  if Uppercase(xNewWord) = 'INDENT6' then begin
    newword := char(1);
    indent := 6;
    result := true;
  end;
  if Uppercase(xNewWord) = 'INDENT8' then begin
    newword := char(1);
    indent := 8;
    result := true;
  end;
  if Uppercase(xNewWord) = 'INDENT10' then begin
    newword := char(1);
    indent := 10;
    result := true;
  end;
  if Uppercase(xNewWord) = 'INDENTOFF' then begin
    newword := char(1);
    indent := 0;
    result := true;
  end;
  if Uppercase(xNewWord) = 'CAPSON' then begin
    newword := char(1);
    capson := true;
    result := true;
  end;
  if Uppercase(xNewWord) = 'CAPSOFF' then begin
    newword := char(1);
    capson := false;
    result := true;
  end;
  if Uppercase(xNewWord) = 'OUTPUTOFF' then begin
    newword := char(1);
    OutputOn := False;
    result := true;
  end;
  if Uppercase(xNewWord) = 'OUTPUTON' then begin
    newword := char(1);
    OutputOn := True;
    result := true;
  end;
end;

function CheckIfValidObjectOutput(xNewWord: string; XBaseForm: TWinControl; MemoErrors: TMemo): Boolean;
var
  zz: integer;
  CompareString: string;
  tempComponent: tComponent;
begin
  if blanktemplate = true then begin
    result := true;
    outputon := true;
    exit;
  end;

  //OutputOn:=False;
  result := False;
  NewWord := '';
  CompareString := '';
  xNewWord := Copy(xNewWord, 3, Length(xNewWord) - 4);
  if Pos('=', xNewWord) > 0 then begin
    CompareString := Trim(Copy(xNewWord, Pos('=', xNewWord) + 1, length(xNewWord)));
    xNewWord := Trim(Copy(xNewWord, 1, Pos('=', xNewWord) - 1));
    if CompareString = '' then
      CompareString := char(1);
  end;
  if xNewWord = '' then begin
    OutputOn := True;
    Result := True;
    exit;
  end;
  if Uppercase(xNewWord) = 'PROBLEMLIST' then begin
    if ProblemListString <> '' then begin
      OutputOn := True;
      result := True;
      exit;
    end;
  end;
  //If xBaseForm.ComponentCount-1>0 then
  //  For xx:=0 to xBaseForm.ComponentCount-1 do begin;
  tempComponent := xBaseform.FindComponent(xNewWord);
  if tempComponent <> nil then begin
    if UpperCase(tempComponent.Name) = Uppercase(xNewWord) then begin
      result := true;
      if (Uppercase(tempComponent.ClassName) = 'TLABEL') then begin
        tempTLabel := tempComponent as TLabel;
        if tempTLabel.visible = True then
          if comparestring <> '' then begin
            if CompareString = char(1) then
              CompareString := '';
            if tempTLabel.Caption = CompareString then
              OutputOn := True;
          end
          else
            if tempTLabel.Caption <> '' then
              OutputOn := True;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TPANEL') then begin
        tempTPanel := tempComponent as TPanel;
        if tempTPanel.visible = True then
          if comparestring <> '' then begin
            if CompareString = char(1) then
              CompareString := '';
            if tempTPanel.Caption = CompareString then
              OutputOn := True;
          end
          else
            if tempTPanel.Caption <> '' then
              OutputOn := True;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TGROUPBOX') then begin
        tempTGroupBox := tempComponent as TGroupBox;
        if tempTGroupBox.visible = True then
          if comparestring <> '' then begin
            if CompareString = char(1) then
              CompareString := '';
            if tempTGroupBox.Caption = CompareString then
              OutputOn := True;
          end
          else
            if tempTGroupBox.Caption <> '' then
              OutputOn := True;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TSCROLLBOX') then begin
        tempTScrollBox := tempComponent as TScrollBox;
        if tempTScrollBox.visible = True then
          NewWord := '<INVALID OBJECT: SCROLLBOX>';
      end;
      if (Uppercase(tempComponent.ClassName) = 'TBUTTON') then begin
        tempTButton := tempComponent as TButton;
        if tempTButton.visible = True then
          if comparestring <> '' then begin
            if CompareString = char(1) then
              CompareString := '';
            if tempTButton.Caption = CompareString then
              OutputOn := True;
          end
          else
            if tempTButton.Caption <> '' then
              OutputOn := True;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TLISTBOX') then begin
        tempTListBox := tempComponent as TListBox;
        if TempTListBox.Multiselect = False then begin
          if tempTListBox.visible = True then
            if comparestring <> '' then begin
              if (CompareString = char(1)) and (tempTListBox.ItemIndex = -1) then
                OutputOn := True;
              if tempTListBox.ItemIndex <> -1 then
                if
                  tempTListBox.Items[tempTListBox.ItemIndex] = CompareString then
                  OutputOn := True;
            end
            else
              if tempTListBox.ItemIndex <> -1 then
                OutputOn := True;
        end
        else begin
          if TempTListbox.visible = True then
            if TempTListBox.Items.Count > 0 then
              for zz := 0 to TempTListBox.Items.Count - 1 do
                if TempTListBox.Selected[zz] = True then
                  if CompareString <> '' then begin
                    if (CompareString = char(1)) and (tempTListBox.ItemIndex = -1) then
                      OutputOn := True;
                    if TempTListBox.Items[zz] = CompareString then
                      OutputOn := True;
                  end
                  else
                    OutputOn := True;
        end;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TORLISTBOX') then begin
        tempTORListBox := tempComponent as TORListBox;
        if TempTORListBox.Multiselect = False then begin
          if tempTORListBox.visible = True then
            if comparestring <> '' then begin
              if (CompareString = char(1)) and (tempTORListBox.ItemIndex = -1) then
                OutputOn := True;
              if tempTORListBox.ItemIndex <> -1 then
                if
                  tempTORListBox.Items[tempTORListBox.ItemIndex] = CompareString then
                  OutputOn := True;
            end
            else
              if tempTORListBox.ItemIndex <> -1 then
                OutputOn := True;
        end
        else begin
          if TempTORListBox.visible = True then
            if TempTORListBox.Items.Count > 0 then
              for zz := 0 to TempTORListBox.Items.Count - 1 do
                if TempTORListBox.Selected[zz] = True then
                  if CompareString <> '' then begin
                    if (CompareString = char(1)) and (tempTORListBox.ItemIndex = -1) then
                      OutputOn := True;
                    if TempTORListBox.Items[zz] = CompareString then
                      OutputOn := True;
                  end
                  else
                    OutputOn := True;
        end;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TRADIOGROUP') then begin
        tempTRadioGroup := tempComponent as TRadioGroup;
        if tempTRadioGroup.visible = True then
          if comparestring <> '' then begin
            if (CompareString = char(1)) and (tempTRadioGroup.ItemIndex = -1) then
              OutputOn := True;
            if tempTRadioGroup.ItemIndex > -1 then
              if tempTRadioGroup.Items[tempTRadioGroup.ItemIndex] = CompareString then
                OutputOn := True;
          end
          else
            if tempTRadioGroup.ItemIndex > -1 then
              OutputOn := True;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TCPWMRADIOGROUP') then begin
        tempTCPWMRadioGroup := tempComponent as TCPWMRadioGroup;
        if tempTCPWMRadioGroup.visible = True then
          if comparestring <> '' then begin
            if (CompareString = char(1)) and (tempTCPWMRadioGroup.ItemIndex = -1) then
              OutputOn := True;
            if tempTCPWMRadioGroup.ItemIndex > -1 then
              if tempTCPWMRadioGroup.Items[tempTCPWMRadioGroup.ItemIndex] = CompareString then
                OutputOn := True;
          end
          else
            if tempTCPWMRadioGroup.ItemIndex > -1 then
              OutputOn := True;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TCOMBOBOX') then begin
        tempTComboBox := tempComponent as TComboBox;
        //tempTComboBox.ItemIndex:=-1;
        if tempTComboBox.visible = True then
          if comparestring <> '' then begin
            if CompareString = char(1) then
              CompareString := '';
            if tempTComboBox.Text = CompareString then
              OutputOn := True;
          end
          else
            if tempTComboBox.Text <> '' then
              OutputOn := True;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TEDIT') then begin
        tempTEdit := tempComponent as Tedit;
        if tempTEdit.visible = True then
          if comparestring <> '' then begin
            if CompareString = char(1) then
              CompareString := '';
            if tempTEdit.Text = CompareString then
              OutputOn := True;
          end
          else
            if tempTEdit.Text <> '' then
              OutputOn := True;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TMEMO') then begin
        tempTMemoBox := tempComponent as TMemo;
        if tempTMemoBox.visible = True then begin
          tempTMemoBox.Text := trim(tempTMemoBox.Text);
          if tempTMemoBox.Lines.Count > 0 then
            OutputOn := True;
        end;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TCHECKBOX') then begin
        tempTCHECKBOX := tempComponent as TCHECKBOX;
        if tempTCheckBox.visible = True then
          if tempTCheckbox.Checked then
            OutputOn := True;
      end;
      if (Uppercase(tempComponent.ClassName) = 'TRADIOBUTTON') then begin
        tempTRADIOBUTTON := tempComponent as TRADIOBUTTON;
        if tempTRadioButton.visible = true then
          if tempTRadioButton.Checked then
            OutputOn := True;
      end;
    end;
  end;
end;

procedure PNCSReportRun(MemoCode: TRichEdit; MemoReport: TRichEdit; XBaseForm: TWinControl; MemoErrors: TMemo; tempMemoryStream: tStream);
var
  x: integer;
begin
  MemoReport.Lines.Clear;
  OutputStringList := TStringList.Create;
  OutputStringList.Clear;
  WhichLine := 0;
  ErrorCount := 0;
  MemoErrors.Lines.Clear;
  CapsOn := False;
  Indent := 0;
  OutputOn := True;
  if memoCode.Lines.Count = 0 then begin
    MemoErrors.Lines.Add('<No report text has been entered>');
    exit;
  end;
  repeat
    CodeString := MemoCode.Lines[WhichLine];
    LineNew := '';
    //Interpret current line here
    if CodeString <> '' then
      repeat begin
          if Pos(' ', CodeString) > 0 then
            NewWord := Copy(Codestring, 1, Pos(' ', codestring) - 1)
          else
            NewWord := CodeString;
          if Pos(' ', CodeString) > 0 then
            CodeString := Copy(CodeString, Pos(' ', CodeString) + 1, Length(CodeString))
          else
            CodeString := ''; // Delete word that was just found
          // Find 1st word
          // Interpret 1st word
          //If Pos('MESSAGE',UpperCase(NewWord))=1 then begin;
          //  InterpretCommandMessage(CodeString, MemoErrors);
          //  CodeString:='';
          if Length(NewWord) > 3 then
            if (Uppercase(Copy(NewWord, 1, 2)) = '##') and (Uppercase(Copy(NewWord, Length(NewWord) - 1, 2)) = '##') then begin
              if CheckIfValidObjectOutput(NewWord, xBaseForm, MemoErrors) = False then begin
                inc(ErrorCount);
                MemoErrors.Lines.Add('Command or object <' + NewWord + '> not recognized on line <' + IntToStr(WhichLine + 1) + '>');
                newword := char(1);
              end
              else
                newword := char(1);
            end
            else
              if Length(NewWord) > 4 then begin
                if (Uppercase(Copy(NewWord, 1, 2)) = '<<') and (Uppercase(Copy(NewWord, Length(NewWord) - 1, 2)) = '>>') then begin
                  if CheckIfValidObjectorCommand(NewWord, xBaseForm, MemoErrors) = False then begin
                    inc(ErrorCount);
                    MemoErrors.Lines.Add('Command or object <' + NewWord + '> not recognized on line <' + IntToStr(WhichLine + 1) + '>');
                    newword := char(1);
                  end;
                end;
              end;
          if NewWord <> char(1) then
            LineNew := LineNew + NewWord + ' ';
          if NewWord = '' then
            LineNew := LineNew + ' ';
          //end else
      end until CodeString = '';
    AddToReport(LineNew, MemoReport);
    //Interpret end
    Inc(WhichLine);
  until WhichLine = MemoCode.Lines.Count;
  if ErrorCount = 0 then
    MemoErrors.Lines.Add('<No errors found>');
  MemoErrors.Lines.Add('<Lines evalutated = ' + IntToStr(MemoCode.Lines.Count) + '>');

  if MemoReport.Lines.Count > 0 then
    for x := 0 to MemoReport.Lines.Count - 1 do
      OutputStringList.Add(MemoReport.Lines[x]);
  //OutputStringList.Add('}');

  OutputStringList.SaveToStream(tempMemoryStream);
  OutputStringList.Free;

end;

initialization

finalization

end.

