unit rofinder;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  Diaccess,
  Fmcmpnts,
  StdCtrls,
  ORCtrls,
  Fmcntrls,
  ExtCtrls,
  Main;

type
  TfrmROFinder = class(TForm)
    ListBoxSites: TListBox;
    Button1: TButton;
    ORListBoxSites: TORListBox;
    FMFinder1: TFMFinder;
    FMListBox1: TFMListBox;
    buttonOK: TButton;
    buttonCancel: TButton;
    timercancel: TTimer;
    TimerOK: TTimer;
    CCOWTimer: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure buttonOKClick(Sender: TObject);
    procedure buttonCancelClick(Sender: TObject);
    procedure ORListBoxSitesClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure timercancelTimer(Sender: TObject);
    procedure TimerOKTimer(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
  private
    { Private declarations }
    function PadRight(S: String; Ch: Char; Len: Integer): String;  //CodeCR169 - rpm 2/1/2011
  public
    { Public declarations }
    function GetCurrentROName: String;  //CodeCR170 - rpm 3/10/11
  end;

var
  frmROFinder: TfrmROFinder;

implementation

{$R *.DFM}

procedure TfrmROFinder.Button1Click(Sender: TObject);
var
  x, y: integer;
  tempString: string;
  spacer: string;
  len: integer;
  sitetype: TStringList;
begin
  sitetype := tstringlist.Create;
  for x := 0 to listboxsites.items.count - 1 do begin
    ListBoxSites.ItemIndex := x;
    application.processmessages;
    FMFinder1.Value := ListBoxSites.Items[x];
    FMListBox1.Items.Clear;
    FMFinder1.GetFinderList(FMListBox1.Items);
    if FMListBox1.Items.Count > 0 then
      for y := 0 to FMListBox1.Items.Count - 1 do begin
        tempString := FMListBox1.Items[y];
        FMListBox1.ItemIndex := y;
        if Length(TempString) > 3 then //CodeCR169 - rpm 2/1/2011 - removed restriction that 4th character must be empty
          ORListBoxSites.Items.Add(FMListBox1.Items[y] + '^' + FMListBox1.GetSelectedRecord.IEN);
      end;
  end;

  if ORListBoxSites.Items.Count > 0 then
    for x := ORListBoxSites.Items.Count - 1 downto 0 do
      if ((Pos('  BVA/VBA-SO', ORListBoxSites.Items[x]) = 0) and
        (Pos('  RO', ORListBoxSites.Items[x]) = 0) and
        (Pos('  VAMC', ORListBoxSites.Items[x]) = 0) and
        (Pos('  CENTRAL OFFICE', ORListBoxSites.Items[x]) = 0) and
        (Pos('  BVA', ORListBoxSites.Items[x]) = 0) and
        (Pos('  M&ROC', ORListBoxSites.Items[x]) = 0) and
        (Pos('  MC&RO', ORListBoxSites.Items[x]) = 0) and
        (Pos('  RO-OC', ORListBoxSites.Items[x]) = 0) and
        (Pos('  RO&IC', ORListBoxSites.Items[x]) = 0) and
        (Pos('  VAMROC', ORListBoxSites.Items[x]) = 0) and
        (Pos('-RO', ORListBoxSites.Items[x]) = 0) and
        (Pos('  VAHSRO', ORListBoxSites.Items[x]) = 0) and
        (Pos('  TIGER TEAM', ORListBoxSites.Items[x]) = 0))
        or
        (Pos('  INACTIVE', ORListBoxSites.Items[x]) > 0)
        then begin
        if Pos('^460', ORListBoxSites.Items[x]) = 0 then // Kludge to keep Wilmington VAMC, 460
          ORListBoxSites.Items.Delete(x);
      end;
  ORListBoxSites.Sorted := False;
  ORListBoxSites.Sorted := True;
  frmROFinder.Caption := 'Site List (' + inttostr(ORListBoxSites.Items.Count) + ' found)';

  (*
  // Change RO to Regional Office
  If ORListBoxSites.Items.Count>0 then
    for x:=ORListBoxSites.Items.Count-1 downto 0 do
      if pos('  RO  ',ORListBoxSites.Items[x])>0 then begin;
        ORListBoxSites.Items[x]:=
          Copy(ORListBoxSites.Items[x],1,pos('  RO  ',ORListBoxSites.Items[x])-3)+
          '  REGIONAL OFFICE  '+
          Copy(ORListBoxSites.Items[x],pos('  RO  ',ORListBoxSites.Items[x])+8,255);
      end;
  *)

  // Just show site number and name
  if ORListBoxSites.Items.Count > 0 then
    for x := ORListBoxSites.Items.Count - 1 downto 0 do
      if pos('  ', ORListBoxSites.Items[x]) > 0 then begin
        tempstring := ORListBoxSites.Items[x];
        //CodeCR169 - rpm 2/1/2011 - added call to PadRight to format variable length station #'s
        ORListBoxSites.Items[x] := PadRight(Copy(tempstring, 1, pos('  ', ORListBoxSites.Items[x]) - 1), ' ', 7);
        tempstring := copy(tempstring, pos('  ', tempstring) + 4, 255);
        ORListBoxSites.Items[x] := ORListBoxSites.Items[x] +
          Copy(tempstring, 1, pos('  ', tempstring) - 1);
        tempstring := copy(tempstring, pos('  ', tempstring) + 4, 255);
        sitetype.insert(0, copy(tempstring, 1, pos('  ', tempstring) - 1));
        tempstring := copy(tempstring, pos('^', tempstring), 255);
        ORListBoxSites.Items[x] := ORListBoxSites.Items[x] + tempstring;
      end;

  // Now count to find longest entry
  len := 0;
  if ORListBoxSites.Items.Count > 0 then
    for x := ORListBoxSites.Items.Count - 1 downto 0 do
      if Length(frmMain.Piece(ORListBoxSites.Items[x], '^', 1)) > len then
        len := Length(frmMain.Piece(ORListBoxSites.Items[x], '^', 1));

  // Now add spaces and type to end
  if ORListBoxSites.Items.Count > 0 then
    for x := ORListBoxSites.Items.Count - 1 downto 0 do begin
      spacer := '';
      for y := 0 to len - length(frmMain.Piece(ORListBoxSites.Items[X], '^', 1)) + 2 do
        spacer := spacer + ' ';
      //ShowMessageCAPRI('*'+sitetype[x]+'*');
      if SiteType[x] = 'RO' then
        SiteType[x] := 'REGIONAL OFFICE';
      ORListBoxSites.Items[x] := ORListBoxSites.Items[x] + '^' + spacer + sitetype[x];
    end;
  sitetype.free;
end;

procedure TfrmROFinder.buttonOKClick(Sender: TObject);
begin
  modalResult := mrOK;
end;

procedure TfrmROFinder.buttonCancelClick(Sender: TObject);
begin
  modalresult := mrcancel;
end;

procedure TfrmROFinder.ORListBoxSitesClick(Sender: TObject);
begin
  buttonOK.Enabled := True;
end;

{=========================================================================
 PadRight
 This function formats a given string by adding given pad characters onto
 the given string for total given length.
 Input:
    S: unformatted string
    Ch: pad character
    Len: total formatted string length

 Output:  Returns a formatted string when unformatted string length is less
          than requested format string length; otherwise, return original
          unformatted string.
 CodeCR169 - rpm - 2/1/2011
 =========================================================================}
function TfrmROFinder.PadRight(S: String; Ch: Char; Len: Integer): String;
var
  RestLen: Integer;
begin
  RestLen := Len - Length(S);
  if RestLen > 0 then
    Result := S + StringOfChar(Ch, RestLen)
  else
    Result := S;
end;

procedure TfrmROFinder.FormActivate(Sender: TObject);
var
  x: integer;
begin
  CCOWTimer.Enabled := True;

  frmROFinder.Visible := False;
  orListBoxSites.ItemIndex := -1;
  buttonOK.Enabled := False;
  if searchforstring <> '' then begin
    if ORListBoxSites.items.count > 0 then
      for x := 0 to ORListBoxSites.items.count - 1 do begin
        if pos('  ' + searchforstring, ORListBoxSites.Items[x]) = length(frmMain.Piece(ORListBoxSites.Items[x], '^', 1)) - length(searchforstring) - 1 then
          if pos('  ' + searchforstring, ORListBoxSites.Items[x]) > 0 then begin
            ORListBoxSites.itemindex := x;
            buttonokclick(application);
          end;
      end;
    if ORListBoxSites.itemindex = -1 then begin
      timercancel.enabled := true;
    end
    else
      timerok.enabled := true;
  end;
  if (timercancel.enabled = false) and (timerok.enabled = false) then
    frmROFinder.Visible := True;
  if ANUReportsClosing = True then
    modalresult := mrCancel;
end;

{========================================================================
 GetCurrentROName
 This function parses the Regional Office name from a selected sitelist
 entry and returns the name on success; otherwise, it returns an empty
 string.

 Input:  none
 Output:  Regional office name on success; otherwise ''

 CodeCR170 - rpm 3/10/11
 ========================================================================}
function TfrmROFinder.GetCurrentROName: String;
begin
  Result := '';
  if (ORListBoxSites.ItemIndex > -1) then
  begin
    Result := frmMain.Piece(ORListBoxSites.Items[ORListBoxSites.ItemIndex], '^', 1);
    Result := TrimLeft(Copy(Result, pos(' ', Result), 255));
  end;
end;

procedure TfrmROFinder.timercancelTimer(Sender: TObject);
begin
  timercancel.enabled := false;
  modalresult := mrcancel;
end;

procedure TfrmROFinder.TimerOKTimer(Sender: TObject);
begin
  timerok.enabled := false;
  ModalResult := mrOK;
end;

procedure TfrmROFinder.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    frmROFinder.Visible := False;
    ContextorChangeMessage := '';
    ModalResult := mrCancel;
  end;
end;

end.
