unit siteexamlist;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Fmcntrls,
  Main,
  ExtCtrls,
  CheckLst,
  Diaccess,
  Fmcmpnts,
  CAPRISupport,
  DiTypLib;

type
  TfrmSiteExamList = class(TForm)
    Panel1: TPanel;
    FMListerCustomExamListDivisionsListBox: TFMListBox;
    Label1: TLabel;
    FMListBoxAvailableExamLists: TFMListBox;
    buttonAdd: TButton;
    buttonEdit: TButton;
    buttonDelete: TButton;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    FMEditNameOfList: TFMEdit;
    CheckListBoxExamList: TCheckListBox;
    Label4: TLabel;
    RadioGroupDefault: TRadioGroup;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Button5: TButton;
    Button6: TButton;
    FMListerCustomExamListDivisions: TFMLister;
    FMEditCAPRIDivisionExamList: TFMEdit;
    FMEditCAPRIExamListDefinition: TFMEdit;
    FMExamsList: TFMListBox;
    CustomExamListDivisions: TFMGets;
    FMListerAvailableExamLists: TFMLister;
    FMListBoxExamSetup: TFMListBox;
    FMListerExamSetup: TFMLister;
    FMGetsCustomExamListSpecifications: TFMGets;
    FMMemoListComments: TFMMemo;
    FMEditListAppliesTo: TFMEdit;
    FMMemoExamComments: TFMMemo;
    FMGetsSpecificExamSpecs: TFMGets;
    buttonClearUserGroup: TButton;
    FMEditExamNameInList: TFMEdit;
    FMValidator1: TFMValidator;
    FMFiler1: TFMFiler;
    FMMemoDivisionComments: TFMMemo;
    CheckBoxInactivate: TCheckBox;
    FMEditInactivateDivision: TFMEdit;
    Label8: TLabel;
    procedure Button6Click(Sender: TObject);
    procedure FMListerCustomExamListDivisionsListBoxClick(Sender: TObject);
    procedure buttonEditClick(Sender: TObject);
    procedure FMListBoxAvailableExamListsClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure CheckListBoxExamListClick(Sender: TObject);
    procedure buttonAddClick(Sender: TObject);
    procedure FMEditNameOfListExit(Sender: TObject);
    procedure buttonClearUserGroupClick(Sender: TObject);
    procedure buttonDeleteClick(Sender: TObject);
    procedure FMEditInactivateDivisionChange(Sender: TObject);
    procedure CheckBoxInactivateClick(Sender: TObject);
    procedure FMEditListAppliesToEnter(Sender: TObject);
    procedure FMEditListAppliesToExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSiteExamList: TfrmSiteExamList;

implementation

uses rofinder;

{$R *.DFM}

procedure TfrmSiteExamList.Button6Click(Sender: TObject);
begin
  // Save changes to inactivate division
  if FMMemoDivisionComments.Enabled = True then
    if FMEditInactivateDivision.FMModified then begin
      if FMEditInactivateDivision.Validate then begin
        FMFiler1.AddChgdControl(FMEditInactivateDivision);
        FMEditInactivateDivision.Text := FMEditInactivateDivision.FMCtrlExternal;
        if not FMFiler1.Update then begin
          ShowMessageCAPRI('There was a problem saving data.');
          exit;
        end;
      end
      else begin
        FMValidator1.DisplayErrors;
        FMEditInactivateDivision.Text := FMEditInactivateDivision.FMTag;
        exit;
      end;
    end;

  // Save changes if new usergroup/institution is picked
  if FMMemoDivisionComments.Enabled = True then begin
    if FMMemoDivisionComments.FMModified then
      FMFiler1.AddChgdControl(FMMemoDivisionComments);
    if FMFiler1.AnythingToFile then
      if not FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem saving data.');
        exit;
      end;
  end;
  //
  ModalResult := mrOK;
end;

procedure TfrmSiteExamList.FMListerCustomExamListDivisionsListBoxClick(Sender: TObject);
begin
  // Save changes to inactivate division
  if FMMemoDivisionComments.Enabled = True then
    if FMEditInactivateDivision.FMModified then begin
      if FMEditInactivateDivision.Validate then begin
        FMFiler1.AddChgdControl(FMEditInactivateDivision);
        FMEditInactivateDivision.Text := FMEditInactivateDivision.FMCtrlExternal;
        if not FMFiler1.Update then begin
          ShowMessageCAPRI('There was a problem saving data.');
          exit;
        end;
      end
      else begin
        FMValidator1.DisplayErrors;
        FMEditInactivateDivision.Text := FMEditInactivateDivision.FMTag;
        exit;
      end;
    end;

  // Save changes if new usergroup/institution is picked
  if FMMemoDivisionComments.Enabled = True then begin
    if FMMemoDivisionComments.FMModified then
      FMFiler1.AddChgdControl(FMMemoDivisionComments);
    if FMFiler1.AnythingToFile then
      if not FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem saving data.');
        exit;
      end;
  end;
  //
  FMListerAvailableExamLists.IENS := ',' + FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
  CustomExamListDivisions.IENS := FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
  FMMemoDivisionComments.IENS := CustomExamListDivisions.IENS;
  FMEditInactivateDivision.IENS := CustomExamListDivisions.IENS;
  CustomExamListDivisions.GetAndFill;
  FMListBoxAvailableExamLists.GetList;
  ButtonEdit.Enabled := False;
  ButtonDelete.Enabled := False;
end;

procedure TfrmSiteExamList.buttonEditClick(Sender: TObject);
var
  x: integer;
begin
  Panel2.Visible := True;

  // Save changes to inactivate division
  if FMMemoDivisionComments.Enabled = True then
    if FMEditInactivateDivision.FMModified then begin
      if FMEditInactivateDivision.Validate then begin
        FMFiler1.AddChgdControl(FMEditInactivateDivision);
        FMEditInactivateDivision.Text := FMEditInactivateDivision.FMCtrlExternal;
        if not FMFiler1.Update then begin
          ShowMessageCAPRI('There was a problem saving data.');
          exit;
        end;
      end
      else begin
        FMValidator1.DisplayErrors;
        FMEditInactivateDivision.Text := FMEditInactivateDivision.FMTag;
        exit;
      end;
    end;

  // Save changes if new usergroup/institution is picked
  if FMMemoDivisionComments.Enabled = True then begin
    if FMMemoDivisionComments.FMModified then
      FMFiler1.AddChgdControl(FMMemoDivisionComments);
    if FMFiler1.AnythingToFile then
      if not FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem saving data.');
        exit;
      end;
  end;
  //
  FMMemoExamComments.Visible := False;
  RadioGroupDefault.Enabled := False;
  FMEditListAppliesTo.Enabled := True;
  buttonClearUserGroup.Enabled := True;
  FMEditNameOfList.Enabled := True;
  RadioGroupDefault.ItemIndex := 1;
  if FMListBoxAvailableExamLists.Items[FMListBoxAvailableExamLists.ItemIndex] = 'DEFAULT LIST' then begin
    RadioGroupDefault.ItemIndex := 0;
    FMEditListAppliesTo.Enabled := False;
    buttonClearUserGroup.Enabled := False;
    FMEditNameOfList.Enabled := False;
  end;
  FMGetsCustomExamListSpecifications.IENS := FMListBoxAvailableExamLists.GetSelectedRecord.IEN + ',' + FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
  FMMemoListComments.IENS := FMGetsCustomExamListSpecifications.IENS;
  FMGetsCustomExamListSpecifications.GetAndFill;
  FMListerExamSetup.IENS := ',' + FMListBoxAvailableExamLists.GetSelectedRecord.IEN + ',' + FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
  FMListBoxExamSetup.GetList;
  CheckListBoxExamList.Items.Clear;
  for x := 0 to FMListBoxExamSetup.Items.Count - 1 do begin
    CheckListBoxExamList.Items.Add(Copy(FMListBoxExamSetup.Items[x], 1, Pos('  ', FMListBoxExamSetup.Items[x])));
    if Pos('  YES', FMListBoxExamSetup.Items[x]) > 0 then
      CheckListBoxExamList.Checked[x] := True;
  end;
  FMEditListAppliesTo.IENS := FMGetsCustomExamListSpecifications.IENS;
  buttonEdit.Enabled := False;    //CodeCR200 - rpm 11/3/11
  buttonDelete.Enabled := False;  //CodeCR200 - rpm 11/3/11
  Panel2.BringToFront;
  // Panel2.Visible:=True;
end;

procedure TfrmSiteExamList.FMListBoxAvailableExamListsClick(
  Sender: TObject);
begin
  ButtonDelete.Enabled := False;
  ButtonEdit.Enabled := True;
  if FMListBoxAvailableExamLists.Items[FMListBoxAvailableExamLists.ItemIndex] <> 'DEFAULT LIST' then
    ButtonDelete.Enabled := True;
end;

procedure TfrmSiteExamList.Button5Click(Sender: TObject);
var
  z: integer;
begin
  if FMEditNameOfList.Text <> '@' then begin
    if (RadioGroupDefault.ItemIndex > 0) and (FMEditListAppliesTo.Text = '') then begin
      ShowMessageCAPRI('This list will be saved but will not be visible to any users.');
    end;
  end;

  // Save comments
  if FMMemoListComments.FMModified then begin
    FMFiler1.AddChgdControl(FMMemoListComments);
    if not FMFiler1.Update then begin
      ShowMessageCAPRI('There was a problem saving data.');
      exit;
    end;
  end;
  if FMMemoExamComments.FMModified then begin
    FMFiler1.AddChgdControl(FMMemoExamComments);
    if not FMFiler1.Update then begin
      ShowMessageCAPRI('There was a problem saving data.');
      exit;
    end;
  end;
  // Save changes if new usergroup/institution is picked
  if FMEditListAppliesTo.FMModified then begin
    if FMEditListAppliesTo.Validate then begin
      FMFiler1.AddChgdControl(FMEditListAppliesTo);
      FMEditListAppliesTo.Text := FMEditListAppliesTo.FMCtrlExternal;
      if not FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem saving data.');
        exit;
      end;
    end
    else begin
      FMValidator1.DisplayErrors;
      FMEditListAppliesTo.Text := FMEditListAppliesTo.FMTag;
      exit;
    end;
  end;

  // Determine if any checkboxes were changed
  for z := 0 to CheckListBoxExamList.Items.Count - 1 do begin
    FMListBoxExamSetup.ItemIndex := z;
    if ((CheckListBoxExamList.Checked[z] = true) and (Pos('  YES', FMListBoxExamSetup.Items[z]) = 0)) then begin
      FMFiler1.AddFDA('396.1514', FMListBoxExamSetup.GetSelectedRecord.IEN + ',' + FMListBoxAvailableExamLists.GetSelectedRecord.IEN + ',' + FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN, '2', 'Y');
      if not FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem saving data.');
        exit;
      end;
    end;
    if ((CheckListBoxExamList.Checked[z] = false) and (Pos('  NO', FMListBoxExamSetup.Items[z]) = 0)) then begin
      FMFiler1.AddFDA('396.1514', FMListBoxExamSetup.GetSelectedRecord.IEN + ',' + FMListBoxAvailableExamLists.GetSelectedRecord.IEN + ',' + FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN, '2', 'N');
      if not FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem saving data.');
        exit;
      end;
    end;
  end;

  // Save changes to name of list
  if FMEditNameOfList.FMModified then begin
    if FMEditNameOfList.Validate then begin
      FMFiler1.AddChgdControl(FMEditNameOfList);
      FMEditNameOfList.Text := FMEditNameOfList.FMCtrlExternal;
      if not FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem saving data.');
        exit;
      end;
    end
    else begin
      FMValidator1.DisplayErrors;
      FMEditNameOfList.Text := FMEditNameOfList.FMTag;
      exit;
    end;
  end;

  FMListBoxAvailableExamLists.GetList;
  Panel2.Visible := False;
end;

procedure TfrmSiteExamList.CheckListBoxExamListClick(Sender: TObject);
begin
  if FMMemoExamComments.FMModified then begin
    FMFiler1.AddChgdControl(FMMemoExamComments);
    if not FMFiler1.Update then begin
      FMFiler1.DisplayErrors;
      exit;
    end;
  end;

  FMListBoxExamSetup.ItemIndex := CheckListBoxExamList.ItemIndex;
  FMGetsSpecificExamSpecs.IENS := FMListBoxExamSetup.GetSelectedRecord.IEN + ',' + FMListBoxAvailableExamLists.GetSelectedRecord.IEN + ',' + FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
  FMMemoExamComments.IENS := FMGetsSpecificExamSpecs.IENS;
  FMGetsSpecificExamSpecs.GetAndFill;
  FMMemoExamComments.Visible := True;
end;

procedure TfrmSiteExamList.buttonAddClick(Sender: TObject);
var
  IEN, ZIEN: string;
  z: integer;
begin
  // Save changes to inactivate division
  if FMMemoDivisionComments.Enabled = True then
    if FMEditInactivateDivision.FMModified then begin
      if FMEditInactivateDivision.Validate then begin
        FMFiler1.AddChgdControl(FMEditInactivateDivision);
        FMEditInactivateDivision.Text := FMEditInactivateDivision.FMCtrlExternal;
        if not FMFiler1.Update then begin
          ShowMessageCAPRI('There was a problem saving data.');
          exit;
        end;
      end
      else begin
        FMValidator1.DisplayErrors;
        FMEditInactivateDivision.Text := FMEditInactivateDivision.FMTag;
        exit;
      end;
    end;

  // Save changes if new usergroup/institution is picked
  if FMMemoDivisionComments.Enabled = True then begin
    if FMMemoDivisionComments.FMModified then
      FMFiler1.AddChgdControl(FMMemoDivisionComments);
    if FMFiler1.AnythingToFile then
      if not FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem saving data.');
        exit;
      end;
  end;
  //
  frmMain.StatusBarLoadPt.Caption := 'Setting up new entry.';
  frmMain.StatusBarLoadPt.Repaint;
  Application.Processmessages;
  IEN := FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
  FMFiler1.AddFDA('396.151', '+1,' + IEN, '.01', 'NEW LIST');
  FMFiler1.AddFDA('396.151', '+1,' + IEN, '2', 'N');
  //If not FMValidator1.Validate then begin; FMValidator1.DisplayErrors; exit; end
    //else
  if not FMFiler1.Update then begin
    ShowMessageCAPRI('There was a problem saving data.');
    exit;
  end;
  ZIEN := FMFiler1.FindIEN('+1,') + ',' + IEN;
  for z := 0 to FMExamsList.Items.Count - 1 do begin
    frmMain.StatusBarLoadPt.Caption := 'Setting up new Exam: ' + FMExamsList.Items[z];
    frmMain.StatusBarLoadPt.Repaint;
    Application.Processmessages;
    FMExamsList.ItemIndex := z;
    FMEditCAPRIExamListDefinition.Text := '`' + FMExamsList.GetSelectedRecord.IEN;
    FMEditCAPRIExamListDefinition.IENS := '+1,' + ZIEN;
    if FMEditCAPRIExamListDefinition.Validate then begin
      FMFiler1.AddChgdControl(FMEditCAPRIExamListDefinition);
      FMEditCAPRIExamListDefinition.Text := FMEditCAPRIExamListDefinition.FMCtrlExternal;
    end
    else begin
      FMValidator1.DisplayErrors;
      FMEditCAPRIExamListDefinition.Text := FMEditCAPRIExamListDefinition.FMTag;
      exit;
    end;
    FMFiler1.AddFDA('396.1514', '+1,' + ZIEN, '2', 'Y');
    if not FMFiler1.Update then begin
      ShowMessageCAPRI('There was a problem populating the exam list.');
      exit;
    end;
  end; // end of exam list population
  frmMain.StatusBarLoadPt.Caption := 'Ready.';
  frmMain.StatusBarLoadPt.Repaint;
  Application.Processmessages;
  FMListBoxAvailableExamLists.GetList;
  buttonEdit.Enabled := False;    //CodeCR200 - rpm 11/3/11
  buttonDelete.Enabled := False;  //CodeCR200 - rpm 11/3/11
  // FMListBoxAvailableExamLists.ItemIndex:=FMListBoxAvailableExamLists.Items.Count-1;
  // buttonEditClick(Application);
end;

procedure TfrmSiteExamList.FMEditNameOfListExit(Sender: TObject);
begin
  if Length(FMEditNameOfList.Text) = 0 then begin
    ShowMessageCAPRI('The list name must contain at least one character.');
    FMEditNameOfList.SetFocus;
    exit;
  end;
  if FMEditNameOfList.Text = 'DEFAULT LIST' then begin
    ShowMessageCAPRI('That is a reserved name.');
    FMEditNameOfList.SetFocus;
    exit;
  end;
  FMEditNameofList.Text := Uppercase(FMEditNameofList.Text);
end;

procedure TfrmSiteExamList.buttonClearUserGroupClick(Sender: TObject);
begin
  FMEditListAppliesTo.Text := '@';
  FMEditListAppliesToExit(Application);
end;

procedure TfrmSiteExamList.buttonDeleteClick(Sender: TObject);
begin
  // Save changes to inactivate division
  if FMMemoDivisionComments.Enabled = True then
    if FMEditInactivateDivision.FMModified then begin
      if FMEditInactivateDivision.Validate then begin
        FMFiler1.AddChgdControl(FMEditInactivateDivision);
        FMEditInactivateDivision.Text := FMEditInactivateDivision.FMCtrlExternal;
        if not FMFiler1.Update then begin
          ShowMessageCAPRI('There was a problem saving data.');
          exit;
        end;
      end
      else begin
        FMValidator1.DisplayErrors;
        FMEditInactivateDivision.Text := FMEditInactivateDivision.FMTag;
        exit;
      end;
    end;

  // Save changes if new usergroup/institution is picked
  if FMMemoDivisionComments.Enabled = True then begin
    if FMMemoDivisionComments.FMModified then
      FMFiler1.AddChgdControl(FMMemoDivisionComments);
    if FMFiler1.AnythingToFile then
      if not FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem saving data.');
        exit;
      end;
  end;
  //
  if Application.MessageBox('Are you sure you want to delete the selected list?', 'Confirm Deletion', 4) = 6 then begin
    Panel2.Visible := False;
    buttonEditClick(Application);
    FMEditNameOfList.Text := '@';
    button5Click(Application);
    Panel2.Visible := False;
    FMListBoxAvailableExamLists.GetList;
    buttonedit.enabled := false;
    buttonDelete.Enabled := False;  //CodeCR200 - rpm 11/3/11
  end;
end;

procedure TfrmSiteExamList.FMEditInactivateDivisionChange(Sender: TObject);
begin
  if FMEditInactivateDivision.Text = 'YES' then
    checkboxinactivate.checked := true
  else
    checkboxinactivate.checked := false;
end;

procedure TfrmSiteExamList.CheckBoxInactivateClick(Sender: TObject);
begin
  if CheckBoxInactivate.Checked = true then begin
    FMEditInactivateDivision.Text := 'YES';
    FMListBoxAvailableExamLists.color := clSilver;
  end
  else begin
    FMEditInactivateDivision.Text := 'NO';
    FMListBoxAvailableExamLists.color := clWhite;
  end;
end;

procedure TfrmSiteExamList.FMEditListAppliesToEnter(Sender: TObject);
begin
  if frmROFinder.ShowModal = mrOK then
    if frmROFinder.ORListBoxSites.ItemIndex > -1 then begin
      FMEditListAppliesTo.Text := '`' + frmMain.Piece(frmROFinder.ORListBoxSites.Items[frmROFinder.ORListBoxSites.ItemIndex], '^', 2);
      FMEditListAppliesToExit(Application);
    end;
  try
  Button5.SetFocus except
  end;
  exit;
end;

procedure TfrmSiteExamList.FMEditListAppliesToExit(Sender: TObject);
begin
  // Save changes if new usergroup/institution is picked
  if FMEditListAppliesTo.FMModified then begin
    if FMEditListAppliesTo.Validate then begin
      FMFiler1.AddChgdControl(FMEditListAppliesTo);
      FMEditListAppliesTo.Text := FMEditListAppliesTo.FMCtrlExternal;
      if not FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem saving data.');
        exit;
      end;
    end
    else begin
      FMValidator1.DisplayErrors;
      FMEditListAppliesTo.Text := FMEditListAppliesTo.FMTag;
      exit;
    end;
  end;
end;

end.
